#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function RemoveDriftandExportforKin(num)
	Variable num //how many points (injections) used to line-fit the baseline
	
	If(num)
	
	If(!(strlen(CsrInfo(A)) > 0) || !(strlen(CsrInfo(B)) > 0))
		print "Place cursors A and B first!"
		return -1
	Endif
	
	String CsrInfoA=CsrInfo(A)
	String CsrInfoB=CsrInfo(B)
	
	Wave w=$(StringByKey("TNAME",CsrInfoA))
	Variable start=NumberByKey("POINT",CsrInfoA)
	Variable delta=NumberByKey("POINT",CsrInfoB)-NumberByKey("POINT",CsrInfoA)
	
	If(delta<0)
		print "Place Cursor A on smaller point number than B!"
		return -1
	EndIf
	
	String swOut=nameofwave(w)+"BLC"
	
	
//	print nameofwave(w), "delta=",delta
	
	duplicate/O w mask, $swOut
	Wave wOut=$swOut
	mask=NaN
	
	Variable i
	For(i=0;i<num;i+=1)
		mask[start+delta*i]=1
	EndFor
	
	CurveFit /Q line, w /M=mask
	
	Wave W_coef
	
	wOut[]-=(W_coef[0]+W_coef[1]*x)
	
	AppendtoGraph wOut
	ModifyGraph rgb($(nameofwave(wOut)))=(13056,0,26112)
	
	Save/G wOut as "SPRFC4DiffBLC.txt"
	
	else
	
	CsrInfoA=CsrInfo(A)
	Wave w=$(StringByKey("TNAME",CsrInfoA))
	Save/G w as "SPRFC4DiffBLC.txt"
	
	endif
End

Function GetDrift()

	ChooseActiveDF(1)
	
	Wave/T wDataRef
	Wave Concs
	Wave/T ConcsT
	If(!waveexists(ConcsT))
		Make/T/N=(numpnts(Concs)) ConcsT
		ConcsT[]=num2str(Concs[p])
	EndIf
	
	Variable/G gDrift

	String sMenuList=""
	Variable i
	For(i=7;i<numpnts(wDataRef);i+=1)
		sMenuList+=wDataRef[i]+";"
	EndFor
	
	Prompt i, "Select Data", popup sMenuList
	DoPrompt "Select Data Wave",i
	
	Variable/G gSelectedWave=i
	
	Wave w=$wDataRef[6+i]
	
	Duplicate/O w wBaseLineCorr
	
	Make/O/N=(numpnts(Concs)) swave=0
	DoWindow/K BaseLineCorrection
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1/N=BaseLineCorrection /W=(610,178,1111,525)
	Button bn1,pos={152,188},size={100,20},title="Calculate Drift",proc=correctbline
	Button bn2,pos={182,265},size={50,20},title="OK",proc=closewindow
	SetVariable sv1,pos={6,32},size={374,44},disable=2,title="Drift (1/h)",value=gDrift,noedit=1,font="Arial",fSize=36,limits={-inf,inf,0}
	ListBox lb3,pos={392,14},size={100,300},fSize=15,mode=4,listWave=ConcsT,SelWave=swave
	
	Display/K=1/N=Correction w,wBaseLineCorr
		
End

Function closewindow (bn2) : ButtonControl
	String bn2
	DoWindow/K BaseLineCorrection
	DoWindow/K Correction
	KillWaves/Z wBaseLineCorr
End

Function correctbline (bn1) : ButtonControl
	String bn1
	
	Wave Times
	
	GetWindow Correction,wavelist
	
	Variable/G gSelectedWave
	Variable selectedWave=gSelectedWave
	KillVariables/Z gSelectedWave
	
	
	Wave/T W_wavelist
	Wave w=$(W_wavelist[0][0])
	Wave wC=$(W_wavelist[1][0])
	Wave swave
	Variable/G DCRate
	
	Variable/G gDrift
	
	Variable Y=0
	Variable m=0
	
	Variable i
	For(i=0;i<dimsize(Times,0);i+=1)
		If(swave[i])
			CurveFit /Q line, w[(Times[i][0]-350)*DCRate,(Times[i][0]-50)*DCRate]
			Wave W_coef
//			print "FitStart:",(Times[i][0]-350)*DCRate,"FitEnd:",(Times[i][0]-50)*DCRate,W_coef[0],w_coef[1]
			Y+=W_coef[0]
			m+=W_coef[1]
		EndIf
	EndFor
	Y/=sum(swave)
	m/=sum(swave)
	gDrift=m*3600
	Variable/G gYDrift=Y
	
	wC[]-=Y+m*x
	
	Print "Drift Linefit:",Y,"+",m,"*x"
	KillWaves/Z W_wavelist
End