#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function CorrectDriftandFit(numkap,numntf2,wNtf2)
	Wave wNtf2	//Wave which includes Ntf2 injections on Kap preloaded layer
	Variable numkap	//how many BSA injections to fit (start with 0)
	Variable numntf2
	
	Variable startfitntf2
	
	startfitntf2=DriftCorrectionMult(numkap)
	
	Wave W_coef
	
	Display wNtf2
	
	DriftCorrectionMult(numntf2,win=wNtf2,w=W_coef,sfit=startfitntf2)
	
	WAve wout=$(nameofwave(wNtf2)+"kapcorr")
	
	Display wout
	
End





Function DriftCorrectionMult(num, [win,w,sfit])
	Variable num //number of BSA injections start with 0
	Wave win,w
	Variable sfit
	
	Variable delta=40 //seconds for BSA injection
	
	Variable startfit

	
	If(!ParamisDefault(win))
	
		Wave wData=win
		startfit=sfit
	else
	
		Wave wData=$(stringbykey("TNAME",CsrInfo(A)))
		startfit=pcsr(A)
	
	endif

	
	Variable endfit=NaN
	
	If(!ParamisDefault(w))
		Duplicate/O w wcoef
	endif
	
	Wave Times
	Wave/T wDataRef
	
	Variable/G DCRate
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return -1
	endif
	
	
	Variable i
	
	

	Wave wBSATimes=GetBSATimesSimple()
	
	Cursor/P A $nameofwave(wData) startfit
	
	FindLevel/Q wBSATimes, xcsr(A)
	
	Variable offset
	If(V_flag==0)
		offset=ceil(V_LevelX)
	else
		print "Offset was not found!"
		offset=0
	endif
	
		endfit=(wBSATimes[num+offset][2]+delta)*DCRate
	
	Duplicate/o wData $(nameofwave(wData)+"kapmask"), $(nameofwave(wData)+"kapfit"), $(nameofwave(wData)+"kapcorr")
	
	Wave mask=$(nameofwave(wData)+"kapmask")
	Wave sbfit=$(nameofwave(wData)+"kapfit")
	Wave sbcorr=$(nameofwave(wData)+"kapcorr")
	
	mask=0
	
	Variable c=0
	
	For(i=0;i<(num+offset);i+=1)
		
		if((wBSATimes[i][2]*DCRate-startfit) > 0 && c==0)
			
			mask[startfit,(wBSATimes[i][0])*DCRate]=1
			
			c=1
		endif	
		
		mask[(wBSATimes[i][2]+40)*DCRate,wBSATimes[i+1][0]*DCRate]=1
		
	EndFor
	
	Make/O/D/N=7 W_coef={VCsr(A),80,350,1e-3,1e-4,1e-9,XCsr(A)}
	Make/O/T wConstraints={"K1 >= 0","K2 >= 0", "K3 >= 0","K4 >= 0","K5 >= 0"}
	
	String hold="1000001"
	
	If(!ParamisDefault(w))
		W_coef[3]=wcoef[3]
		W_coef[4]=wcoef[4]
		W_coef[5]=wcoef[5]
		W_coef[6]=wcoef[6]
		startfit=wcoef[6]*DCRate
		W_coef[0]=wData[startfit]
		hold="1001111"
		wConstraints={"K1 >= 0","K2 >= 0"}
	endif
	
//	CurveFit/X=1/NTHR=0 dblexp_XOffset  wData[startfit,endfit] /M=mask /D
	print "startfit",startfit,"endfit",endfit
	FuncFit/X=1/L=(10000)/H=hold/NTHR=0 DissFit3 W_coef wData[startfit,endfit] /M=mask/D/R/C=wConstraints

	
	wave w_coef
	
	sbfit[]=DissFit3(W_coef,x)
	sbcorr-=sbfit

	return pcsr(A)

End




Function/WAVE KapDriftCorrection(num, [w])
	Variable num //number of BSA injections start with 0
	Wave w
	
	Variable delta=40 //seconds for BSA injection
	
	Wave wData=$(stringbykey("TNAME",CsrInfo(A)))
	
	Variable startfit=pcsr(A)
	
	Variable endfit=NaN
	
	If(!ParamisDefault(w))
		Duplicate/O w wcoef
	endif
	
	Wave Times
	Wave/T wDataRef
	
	Variable/G DCRate
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return $""
	endif
	
	
	Variable i

	Wave wBSATimes=GetBSATimesSimple()
	
	endfit=(wBSATimes[num][2]+delta)*DCRate
	
	Duplicate/o wData $(nameofwave(wData)+"kapmask"), $(nameofwave(wData)+"kapfit"), $(nameofwave(wData)+"kapcorr")
	
	Wave mask=$(nameofwave(wData)+"kapmask")
	Wave sbfit=$(nameofwave(wData)+"kapfit")
	Wave sbcorr=$(nameofwave(wData)+"kapcorr")
	
	mask=0
	
	Variable c=0
	
	For(i=0;i<num+1;i+=1)
		
		if((wBSATimes[i][2]*DCRate-startfit) > 0 && c==0)
			
			mask[startfit,(wBSATimes[i][0])*DCRate]=1
			
			c=1
		endif	
		
		mask[(wBSATimes[i][2]+40)*DCRate,Times[i][0]*DCRate]=1
		
	EndFor
	
	Make/O/D/N=7 W_coef={VCsr(A),80,350,1e-3,1e-4,1e-9,XCsr(A)}
	Make/O/T wConstraints={"K1 >= 0","K2 >= 0", "K3 >= 0","K4 >= 0","K5 >= 0"}
	
	String hold="1000001"
	
	If(!ParamisDefault(w))
		W_coef[3]=wcoef[3]
		W_coef[4]=wcoef[4]
		W_coef[5]=wcoef[5]
		W_coef[6]=wcoef[6]
		startfit=wcoef[6]*DCRate
		W_coef[0]=wData[startfit]
		hold="1001111"
		wConstraints={"K1 >= 0","K2 >= 0"}
	endif
	
//	CurveFit/X=1/NTHR=0 dblexp_XOffset  wData[startfit,endfit] /M=mask /D
	FuncFit/X=1/L=(10000)/H=hold/NTHR=0 DissFit3 W_coef wData[startfit,endfit] /M=mask/D/R/C=wConstraints

	
	wave w_coef
	
	sbfit[]=DissFit3(W_coef,x)
	sbcorr-=sbfit
	
	return sbcorr

End
