#pragma rtGlobals=3		// Use modern global access method and strict wave access.

//Small Helper Functions to make usage easier

Function/S ChooseActiveDF(index)
//Lets you choose a data folder and 
//if index=1 sets it as active data folder
//if index=0 the function only returns 
//the path to the selected data folder.

	Variable index

	Wave/T w=root:ExperimentList

	String sMenuList=""
	Variable i
	
	For(i=0;i<(dimsize(w,0));i+=1)
		sMenuList+="E"+w[i][0]+";"
	EndFor
	
	Prompt i, "Select Folder", popup sMenuList
	DoPrompt "Select active Experiment",i
	
	String NewDF="root:"+stringfromlist(i-1,sMenuList)
	
	If(index)
		SetDataFolder NewDF
	EndIf
	
	return NewDF	
	
End

//Choose Flow Cell data folder

Function ChooseActiveFCDF(index)
//Lets you choose a data folder and 
//if index=1 sets it as active data folder
//if index=0 the function only returns 
//the path to the selected data folder.

	Variable index

	Wave/T w=root:ExperimentList
	Wave/T wDataRef

	String sMenuList=""
	Variable i
	For(i=0;i<3;i+=1)
		splitstring/E="(.{7}$)" wDataRef[7+i]
		sMenuList+=S_value+";"
	EndFor
	

	
	Prompt i, "Select Folder", popup sMenuList
	DoPrompt "Select active Experiment",i
	
	Variable/G gSelectedFC=i
	
	String NewDF=":"+stringfromlist(i-1,sMenuList)
	
	If(index)
		SetDataFolder NewDF
	EndIf
	
	return i	
	
End

//Restore Backup Data Waves

Function restore()
	
	Wave/T wDataRef
	
	Wave wT=$(wDataRef[0])	//Time wave
	Wave wFC1=$(wDataRef[1])
	Wave wFC2=$(wDataRef[2])
	Wave wFC3=$(wDataRef[3])
	Wave wFC4=$(wDataRef[4])
	Wave wTb=:Backup:$(wDataRef[0])
	Wave wFC1b=:Backup:$(wDataRef[1])
	Wave wFC2b=:Backup:$(wDataRef[2])
	Wave wFC3b=:Backup:$(wDataRef[3])
	Wave wFC4b=:Backup:$(wDataRef[4])
	

	Duplicate/O wTb wT
	Duplicate/O wFC1b wFC1
	Duplicate/O wFC2b wFC2
	Duplicate/O wFC3b wFC3
	Duplicate/O wFC4b wFC4
	
	
	
End

//Displays Found and Calculated Event Times
Function ReviewTimes()

	Wave/T wDataRef
	
	DoWindow/K SelectPanel
	
	String List="\""+wDataRef[7]+";"+wDataRef[8]+";"+wDataRef[9]+"\""
	PauseUpdate; Silent 1		// building window...
	NewPanel /N=SelectPanel/W=(610,277,1105,662)
	SetDrawLayer UserBack
	SetDrawEnv fsize= 20,fstyle= 1
	DrawText 26,38,"Select Events to Display"
	SetDrawEnv fsize= 20,fstyle= 1
	DrawText 30,187,"Select Flow Cell for displaying"
	PopupMenu pm3,pos={31,192},size={160,21}
	PopupMenu pm3,mode=1,value= #List
	CheckBox cb1,pos={30,51},size={173,23},title="AssStartFromLog"
	CheckBox cb1,font="Arial Greek",fSize=20,value= 0
	CheckBox cb2,pos={28,80},size={178,23},title="DissStartFromLog"
	CheckBox cb2,font="Arial Greek",fSize=20,value= 0
	CheckBox cb3,pos={28,108},size={176,23},title="DissStopFromLog"
	CheckBox cb3,font="Arial Greek",fSize=20,value= 0
	CheckBox cb4,pos={233,55},size={133,23},title="AssStartCalc",font="Arial Greek"
	CheckBox cb4,fSize=20,value= 0
	CheckBox cb5,pos={234,82},size={138,23},title="DissStartCalc",font="Arial Greek"
	CheckBox cb5,fSize=20,value= 0
	CheckBox cb6,pos={234,110},size={136,23},title="DissStopCalc",font="Arial Greek"
	CheckBox cb6,fSize=20,value= 0
	Button bt2,pos={191,241},size={135,67},proc=btn2,title="Continue"
	Button bt2,font="Arial Greek",fSize=15,fColor=(0,52224,0)

End

Function btn2 (ctrlName) : ButtonControl
	String ctrlName
	
	Variable/G DCRate

	ControlInfo/W=SelectPanel pm3
	Variable FCSelected=V_value
	
	ControlInfo/W=SelectPanel cb1
	Variable chk1=V_value*1
	ControlInfo/W=SelectPanel cb2
	Variable chk2=V_value*2
	ControlInfo/W=SelectPanel cb3
	Variable chk3=V_value*4
	ControlInfo/W=SelectPanel cb4
	Variable chk4=V_value*8
	ControlInfo/W=SelectPanel cb5
	Variable chk5=V_value*16
	ControlInfo/W=SelectPanel cb6
	Variable chk6=V_value*32
	
	Variable chk=chk1+chk2+chk3+chk4+chk5+chk6
		
	DoWindow/K SelectPanel
	
	Wave Times
	Wave/T wDataRef
	
	Wave wDisp=$(wDataRef[FCSelected+6]+"SS")
	
	NewDataFolder/O Review
	
	
	Display/K=1 wDisp
	String Wname=S_name
	
	Variable i
	If(chk&chk1)	//Displays Association Start Point from Log
		MakeAndDisplay(wDisp,":Review:MarkerAssStartLog",Times,Wname,"MarkerAssStartLog",0)
	EndIf
	If(chk&chk2)	//Displays Dissociation Start Point from Log
		MakeAndDisplay(wDisp,":Review:MarkerDissStartLog",Times,Wname,"MarkerDissStartLog",1)
	EndIf
	If(chk&chk3)	//Displays Dissociation Stop Point from Log
		MakeAndDisplay(wDisp,":Review:MarkerDissStopLog",Times,Wname,"MarkerDissStopLog",2)
	EndIf
	If(chk&chk4)	//Displays Association Start Point from Finder
		MakeAndDisplay(wDisp,":Review:MarkerAssStartCalc",Times,Wname,"MarkerAssStartCalc",3+(FCSelected-1))
	EndIf
	If(chk&chk5)	//Displays Dissociation Start Point from Finder
		MakeAndDisplay(wDisp,":Review:MarkerDissStartCalc",Times,Wname,"MarkerDissStartCalc",4+(FCSelected+1))
	EndIf
	If(chk&chk6)	//Displays Dissociation Stop Point from Finder
		MakeAndDisplay(wDisp,":Review:MarkerDissStopCalc",Times,Wname,"MarkerDissStopCalc",2)	//Diss Stop is not calculated
	EndIf
	
	Legend/C/N=legend0/A=LT
End

Function MakeAndDisplay(wDisp,path,Times,Wname,s,index)
	Wave wDisp
	String path
	Wave Times
	String Wname
	String s
	Variable index
	
	Variable/G DCRate
	Variable i
	
		Make/D/O/N=(numpnts(wDisp))$path=NaN
		setscale/I x,(leftx(wDisp)),(rightx(wDisp)),"s",$path
		Wave w=$(path)
		For(i=0;i<(dimsize(Times,0));i+=1)
			If(((Times[i][index])*dcrate*10+1)<(numpnts(w)-1))
			w[(Times[i][index])*dcrate*10+1]=wDisp[Times[i][index]*dcrate*10+1]
			endif
		EndFor
		AppendToGraph/W=$Wname $path
		ModifyGraph mode($s)=3,marker($s)=43;DelayUpdate
		ModifyGraph msize($s)=8,rgb($s)=(0,(65280*(1-index*0.3)),(65280*(1-index*0.1)))
		
End

//Interpolates wave w and creates interpolated wave ws
Function Interpolater(w,p)
	Wave w
	Variable p
	
	String wS=nameofwave(w)+"S"
	String wR=nameofwave(w)+"R"
	Duplicate/O w $wS
	Wave m=$wS
	
	Interpolate2/N=(numpnts(w)*p)/Y=$wS w 
	
End


Function ExtractBSABinding()
	Wave Times
	Wave/T wDataRef
	
	Variable/G DCRate
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return -1
	endif
	
	Variable i
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	
	Prompt i, "Select DataWave", popup sMenuList
	DoPrompt "Select DataWave",i
	
	Wave wData=$(wDataRef[i+6])
	
	Make/O/D/N=(dimsize(Times,0)) wBSAbound
	
	Variable k
	For(k=0;k<dimsize(Times,0);k+=1)
		if(k==0)
			wBSAbound[k]=wData[(Times[k][0]-60)*DCRate]-wData[0]
		else
			wBSAbound[k]=wData[(Times[k][0]-60)*DCRate]-wData[Times[k-1][2]*DCRate]
		endif
	EndFor
	
	For(k=0;k<dimsize(Times,0);k+=1)
		if(wBSAbound[k]<0)
		wBSAbound[k]=0
		endif
	EndFor
	
End

Function DisplayBSAPeakPos(wData,wPeakPos,num)
	Wave wData //Contains Data points
	Wave wPeakPos	//Contains BSA Peak Positions (Nx24 Matrix)
	Variable num //If num==0 reference wave is used as wData
	
	Duplicate/O wData wBSAPeakPos
	wBSAPeakPos=NaN
	Variable pos=0
	If(num==0)
		pos=12
	EndIf
	
	Variable i,j
	For(i=0;i<dimsize(wPeakPos,0);i+=1)
		For(j=0;j<12;j+=1)
			If(wPeakPos[i][j])
				wBSAPeakPos[wPeakPos[i][pos+j]]=wData[wPeakPos[i][pos+j]]
			EndIf
		EndFor
	EndFor
	
	
End

Function CalcGraftingDistancePEG(mw,response)
	Variable mw //Molweight in g/mol  //NSP1 18FG: 38kD
	Variable response //deltaRU of SPR binding signal

	Return sqrt(1000*mw/(response*602.2)) //returns grafting distance in nm
	
End

Function CalcGraftingDistanceProt(mw,response)
	Variable mw //Molweight in g/mol
	Variable response //deltaRU of SPR binding signal

	Return sqrt(1300*mw/(response*602.2)) //returns grafting distance in nm
	
End

Function CalcGraftingDistanceProtError(mw,response,sdevresponse)
	Variable mw //Molweight in g/mol
	Variable response //deltaRU of SPR binding signal
	Variable sdevresponse

	Return sqrt((-0.734634/response*sqrt(mw/response)*sdevresponse)^2) //returns grafting distance in nm
	
End

//returns number of molekules/proteins per nm^3
Function CalcGraftingVolumeDensityProt(mw,response,layerheight)
	Variable mw	//Molweight in g/mol
	Variable response	//deltaRU of SPR bindings signal
	Variable layerheight	//layer height in nm
	
	Return (response*602.2)/(1300*layerheight*mw)
	
End

Function CalcRuForProt(mw,g)
	Variable mw //Molweight in g/mol
	Variable g //grafting distance in [nm]
	
	Return (1300*mw)/(g^2*602.2)
End

Function CalcOneLayerResponseProt(mw,hr)
	Variable mw	//Molweight
	Variable hr	//Hydrodynamic radius
	
	return (mw*1300)/((2*hr)^2*602.2)
	
End

Function SubstractFit()

	Wave wD=$(StringbyKey("TNAME",CsrInfo(A)))
	
	String wSub=nameofwave(wD)+"_fitsub"
	
	
	Wave w=w_coef
	
	If(dimsize(w,0)==7)
	
		Duplicate/O wD $wSub
		Wave wS=$wSub
		
		
		wS[]-=(w[0]-w[1]-w[2])*exp(-w[5]*(x-w[6]))+(w[1])*exp(-w[3]*(x-w[6]))+(w[2])*exp(-w[4]*(x-w[6]))
		
		appendtograph wS
		ModifyGraph rgb($nameofwave(wS))=(0,9472,39168)
	else
	
	print "Run DissFit3 first!"
	
	return -1
	
	endif

End

Function CalcBoundAnalyteSurfaceDensity([num,w])
	
	Variable num //number of injections used for positive drift correction.
	Wave w //alternative data wave 
	
	Wave Times
	Wave/T wDataRef
	
	Variable/G DCRate
	
	if(!paramisdefault(num))
		Wave wdatacorr=SoftDriftCorrection(num)
	endif
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return -1
	endif
	
	
	Variable i
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	
	
	

	
	if(!paramisdefault(num))
		Wave wData=wdatacorr
	elseif(!paramisdefault(w))
		Wave wData=w
	else
		Prompt i, "Select DataWave", popup sMenuList
		DoPrompt "Select DataWave",i
		Wave wData=$(wDataRef[i+6])

	endif
	print nameofwave(wData)
	
	String s
	Prompt s, "Date"
	DoPrompt "Date", s
		
	String sABR=s+nameofwave(wData)+"ABR"
	String sAB=s+nameofwave(wData)+"AB"
	String sABI=s+nameofwave(wData)+"ABI"
	String sABRI=s+nameofwave(wData)+"ABRI"
	String sRatio=s+nameofwave(wData)+"Ratio"
	
	Wave wBSATimes=GetBSATimesSimple()
	
	Make/O/D/N=(dimsize(wBSATimes,0)) $sAB=NaN, $sABR=Nan//, pos1=nan
	
	Make/O/D/N=(dimsize(Times,0)+1) $sABI=NaN, $sABRI=NaN//,pos2=nan
	
	Wave wAnalytebound=$sAB
	Wave wAnalyteboundResp=$sABR
	Wave wAnalyteboundInj=$sABI
	Wave wAnalyteboundRespInj=$sABRI
	
	 wAnalytebound[0]=0
	 wAnalyteboundResp[0]=0
	 wAnalyteboundInj[0]=0
	 wAnalyteboundRespInj[0]=0
	
	
	Variable k
	
	Variable start
	
	Variable diff
	diff=wBSATimes[1]/2
	
	if(wBSATimes[0]*1.5<diff)
		start=1
	else
		start=0
	endif

	
	For(k=start;k<dimsize(wBSATimes,0);k+=1)
		wAnalytebound[k]=wData[wBSATimes[k]*DCRate]//-wData[0]
//		pos1[k]=wBSATimes[k]*DCRate
		
	EndFor
	wAnalyteboundResp=wAnalytebound
	
	
	For(k=0;k<dimsize(Times,0);k+=1)
		wAnalyteboundInj[k+1]=wData[(Times[k][1]-30)*DCRate]//-wData[0]
//		pos2[k+1]=(Times[k][1]-30)*DCRate
	EndFor
	
	wAnalyteboundRespInj=wAnalyteboundInj
	
	//Calc Surface density in [Da/nm^2]
	
	wAnalytebound*=(602.2/1300)
	wAnalyteboundInj*=(602.2/1300)
	
	Make/O/D/N=(numpnts(wAnalytebound)) $sRatio
	
	Wave wAnalyteboundratio=$sRatio
	
	wAnalyteboundratio=1-(wAnalytebound/wAnalyteboundInj)
	
	Wave ConcsforHeight
	If(waveexists(ConcsforHeight))
	
	
	
	Display/K=1 wAnalytebound vs ConcsforHeight; appendtograph wAnalyteboundInj vs ConcsforHeight
	appendtograph/R wAnalyteboundratio vs ConcsforHeight
	ModifyGraph mode=4,marker($nameofwave(wAnalytebound))=8,marker($nameofwave(wAnalyteboundInj))=8;DelayUpdate
	ModifyGraph rgb($nameofwave(wAnalyteboundInj))=(0,15872,65280),marker($nameofwave(wAnalyteboundratio))=6;DelayUpdate
	ModifyGraph rgb($nameofwave(wAnalyteboundratio))=(0,39168,0)
	
	Make/O/D/N=20 wAnalyteboundratio_Hist
	Histogram/B={0,0.1,20} wAnalyteboundratio,wAnalyteboundratio_Hist
	Display/K=1 wAnalyteboundratio_Hist
	ModifyGraph mode=5,hbFill=12,toMode=1
	ModifyGraph nticks(bottom)=10
	
	String sConcsOut=s+nameofwave(ConcsForHeight)
	
	Duplicate/O ConcsForHeight $sConcsOut
	
	Wave wConcsOut=$sConcsOut
	
	save/C $sConcsOut as (sConcsOut+".ibw")
	endif
	save/C $sABR as (sABR+".ibw")
	save/C $sAB as (sAB+".ibw")
	save/C $sABI as (sABI+".ibw")
	save/C $sABRI as (sABRI+".ibw")
	save/C $sRatio as (sRatio+".ibw")
	

	
End

Function/WAVE GetBSATimesSimple()

	Variable/G DCRate	//Data capture rate in Hz
	Variable/G numBSA

	Variable/G gToffset
	Variable/G gPoffset
	
	if(!exists("gToffset"))
		gToffset=0
		gPoffset=0
	endif
	
	Wave/T wDataRef	//Contains names of data waves	
	Wave/T wName = $(wDataRef[5])	//Contains Name of event (from logfile)
	Wave wTime = $(wDataRef[6])	//Contains Time of event (from logfile)
	
	make/D/O/N=(0,3) wBSATimes		//It is assumed that a single height measurement
									//is compsed of three BSA injections wrapped in a
									//single Injection Sequence (single cycle kinetics)
									
	//Extract BSA injection Start times from Logfile
	Variable i,j,k,offset=0,count=0
	Variable delta	//seconds from injection ready to middle of two injections.
	For(i=0;i<(numpnts(wName));i+=1)
	
		If(stringmatch(wname(i),"Flow path:*"))
			offset=count*gToffset
			count+=1
		EndIf
		
		If(stringmatch(wName(i), "Inject sequence: Start*"))
			Redimension /N=(dimsize(wBSATimes,0)+1,-1) wBSATimes
			k=0
			For(j=i;j<(numpnts(wName));j+=1)	
				If(stringmatch(wName(j),"Inject: Start*"))
					If(k==1)
						delta=wTime[j+1]-wTime[j]
					EndIf
					If(k<3)//Only first 3 BSA injections are taken into calculation
						wBSATimes[dimsize(wBSATimes,0)-1][k]=wTime[j]//+offset
					//	print "gToffset=",gToffset,"Line=",i,"PeakNumber=",j,"Time=",wTime[j],"offset=",offset,"Out=",wTime[j]+offset
					elseif(k>=3)
						print "More than 3 BSA injections found! ("+num2str(wTime[j])+"seconds"
					EndIf
					k+=1
				Elseif(stringmatch(wName(j),"Inject sequence: Ready*"))
					break
				EndIf
			EndFor
		Endif		
	EndFor	
	
	return wBSATimes

End

Function ExportInitHeight(str, [num])
	String str
	Variable num
	
	Variable pos=0
	
	if(!paramisdefault(num))
	
		pos=num
	endif
	
	
	String swOut="InitialHeight"+str
	
	Wave wh41=root:EMerged:BSAFC4vsFC1:AvgHeight
	Wave wh31=root:EMerged:BSAFC3vsFC1:AvgHeight
	Wave wh41error=root:EMerged:BSAFC4vsFC1:AvgHeightError
	Wave wh31error=root:EMerged:BSAFC3vsFC1:AvgHeightError
	Wave RefAmp41=root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRef
	Wave RefAmp31=root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpRef
	Wave DataAmp41=root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpData
	Wave DataAmp31=root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpData
	Wave RefAmp41error=root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRefError
	Wave RefAmp31error=root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpRefError
	Wave DataAmp41error=root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpDataError
	Wave DataAmp31error=root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpDataError	
	
	Make/O/D/N=16 $swOut //height41;height31;errorheight41;errorheight31;Ref/Data41;Ref/Data;31;Ref/Data error41; Ref/Data error31;Data41;Data31;Ref41;Ref31;Datae41;Datae31;Refe41;Refe31
	Wave wOut=$swOut
	
	wOut[0]=wh41[pos]
	wOut[1]=wh31[pos]
	wOut[2]=wh41error[pos]
	wOut[3]=wh31error[pos]
	wOut[4]=RefAmp41[pos]/DataAmp41[pos]
	wOut[5]=RefAmp31[pos]/DataAmp31[pos]
	wOut[6]=sqrt((RefAmp41error[pos]/DataAmp41[pos])^2+(-RefAmp41[pos]/DataAmp41[pos]^2*DataAmp41error[pos])^2)
	wOut[7]=sqrt((RefAmp31error[pos]/DataAmp31[pos])^2+(-RefAmp31[pos]/DataAmp31[pos]^2*DataAmp31error[pos])^2)
	
	wOut[8]=DataAmp41[pos]
	wOut[9]=DataAmp31[pos]
	wOut[10]=RefAmp41[pos]
	wOut[11]=RefAmp31[pos]
	wOut[12]=DataAmp41error[pos]
	wOut[13]=DataAmp31error[pos]
	wOut[14]=RefAmp41error[pos]
	wOut[15]=RefAmp31error[pos]
	
	Save/C $swOut as (swOut+".ibw")

	
	
End

Function ExportNupGrafting(str,mw)
	String str
	Variable mw
	
	String swOut="NupGrafting"+str
	
	Make/O/D/N=8 $swOut //boundRU41;boundRU31;boundRUerror41;boundRUerror31;graftingdistance41;graftingdistance31;graftingdistanceerror41;graftingdistanceerror31
	Wave wOut=$swOut
	
	Wave SPRFC4Diff
	Wave SPRFC3Diff
	
	Variable Baseline, BaselineError
	Variable Bound, BoundError
	
	Wavestats/Q/R=[0,1120]  SPRFC4Diff //1120
	Baseline=V_avg
	BaselineError=V_sdev
	Wavestats/Q/R=[38115,38825] SPRFC4Diff //38115,38825
	Bound=V_avg
	BoundError=V_sdev
	
	
	wOut[0]=Bound-Baseline
	wOut[2]=sqrt(BaselineError^2+BoundError^2)
	wOut[4]=CalcGraftingDistanceProt(mw,wOut[0])
	wOut[6]=CalcGraftingDistanceProtError(mw,wOut[0],wOut[2])

	Wavestats/Q/R=[0,1120]  SPRFC3Diff //[0,1120] 
	Baseline=V_avg
	BaselineError=V_sdev
	Wavestats/Q/R=[38115,38825] SPRFC3Diff //[38115,38825]
	Bound=V_avg
	BoundError=V_sdev
	
	wOut[1]=Bound-Baseline
	wOut[3]=sqrt(BaselineError^2+BoundError^2)
	wOut[5]=CalcGraftingDistanceProt(mw,wOut[1])
	wOut[7]=CalcGraftingDistanceProtError(mw,wOut[1],wOut[3])
	
	Save/C $swOut as (swOut+".ibw")

End

Function ExportHeights(str)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820
	
	String sConcs="Concs"+str
	String sHeight41="Height41"+str
	String sHeight31="Height31"+str
	String sHeight42="Height42"+str
	String sHeight32="Height32"+str
	
	Wave ConcsForHeight
	If(!waveexists(ConcsForHeight))
		print "ConcsForHeight does not exist!"
		return -1
	EndIf
	
	Duplicate/O ConcsForHeight $sConcs
	Duplicate/O root:EMerged:BSAFC4vsFC1:AvgHeight $sHeight41
	Duplicate/O root:EMerged:BSAFC3vsFC1:AvgHeight $sHeight31
	Duplicate/O root:EMerged:BSAFC4vsFC2:AvgHeight $sHeight42
	Duplicate/O root:EMerged:BSAFC3vsFC2:AvgHeight $sHeight32
	
	Save/C $sConcs as (sConcs+".ibw")
	Save/C $sHeight41 as (sHeight41+".ibw")
	Save/C $sHeight31 as (sHeight31+".ibw")
	Save/C $sHeight42 as (sHeight42+".ibw")
	Save/C $sHeight32 as (sHeight32+".ibw")
	
	KillWaves/Z  $sConcs,$sHeight41,$sHeight31,$sHeight42,$sHeight32

End

Function ExportHeights42(str)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820
	
	String sConcs="Concs"+str
	String sHeight41="Height41"+str
	String sHeight21="Height21"+str

	Wave ConcsForHeight
	If(!waveexists(ConcsForHeight))
		print "ConcsForHeight does not exist!"
		return -1
	EndIf
	
	Duplicate/O ConcsForHeight $sConcs
	Duplicate/O root:EMerged:BSAFC4vsFC1:AvgHeight $sHeight41
	Duplicate/O root:EMerged:BSAFC2vsFC1:AvgHeight $sHeight21

	
	Save/C $sConcs as (sConcs+".ibw")
	Save/C $sHeight41 as (sHeight41+".ibw")
	Save/C $sHeight21 as (sHeight21+".ibw")

	
	KillWaves/Z  $sConcs,$sHeight41,$sHeight21

End

Function ExportKD(str)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820

	ChooseActiveDF(1)	//Choose Experiment
	ChooseActiveFCDF(1)	//Choose Flow Cell
	
	Wave C=concs
	Wave fit=fit_ReqtotLI2
	Wave data=:Fits:Reqtot
	
	String sC=nameofwave(C)+"KD"+str
	String sfit=nameofwave(fit)+str
	String sdata=nameofwave(data)+str
	
	duplicate/O C $sC
	duplicate/O fit $sfit
	duplicate/O data $sdata
	
	save/C $sC as (sC+".ibw")
	save/C $sfit as (sfit+".ibw")
	save/C $sdata as (sdata+".ibw")
End


//ONLY WORKS WHEN ANALYSIS WAS DONE IN NORMALIZED FORM.
Function Export1KD(str)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820
	
	ChooseActiveDF(1)	//Choose Experiment
	ChooseActiveFCDF(1)	//Choose Flow Cell
	
	Wave C=concs
	Wave fit=fit_ReqtotLI
	Wave data=:Fits:Reqtot
	Wave W_coef	//results from two component langmuir isotherm fit
	Wave bakW_coef_singleLI	//results from single componen langmuir isotherm fit
	
	String sC=nameofwave(C)+"singKD"+str
	String sfit=nameofwave(fit)+"sing"+str
	String sdata=nameofwave(data)+"sing"+str
	
	duplicate/O C $sC
	duplicate/O fit $sfit
	Wave wfit=$sfit
	duplicate/O data $sdata
	Wave wdata=$sdata
	
	//reverse normalization by two component LI fit
	wdata*=(W_coef[0]+W_coef[1])
	wfit*=(W_coef[0]+W_coef[1])

	 
	//normalize by single component langmuir isotherm fit rmax.

	wdata/=bakW_coef_singleLI[0]
	wfit/=bakW_coef_singleLI[0]

	
	save/C $sC as (sC+".ibw")
	save/C $sfit as (sfit+".ibw")
	save/C $sdata as (sdata+".ibw")
End

Function ExportKDTime(str)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820
	
	ChooseActiveDF(1)	//Choose Experiment
	ChooseActiveFCDF(1)	//Choose Flow Cell
	
	Wave wkd1=wKD1out
	Wave wkd2=wKD2out
	Wave wtime=wTimeOff
	
	String swkd1=str+"-"+nameofwave(wkd1)
	String swkd2=str+"-"+nameofwave(wkd2)
	String swTimeOff=str+"-"+nameofwave(wtime)
	
	save/C wkd1 as (swkd1+".ibw")
	save/C wkd2 as (swkd2+".ibw")
	save/C wtime as (swTimeOff+".ibw")
End

Function expforkin(num,datum, fc)  //Prepare for interaction map fit in matlab (adds some nonsense to the end and adjusts baseline)
							//export of data and concentration waves to .txt files. 
Variable num //number of injections frm biggest start with 1
String datum	//date of the experiment, e.g. "131118"
String fc	//number of flow cell, e.g. "3"

	Wave w=$(stringbykey("TNAME",CsrInfo(A)))
	
	Redimension/N=(numpnts(w)+1000) w
	
	Variable i
	For(i=numpnts(w)-1001;i<numpnts(w);i+=1)
		w[i]=w[i-1000]
	EndFor
	
	Variable bla=vcsr(A)
	w-=bla
	print pcsr(A)
	
	Wave Concs
	Make/O/N=(num) kinconcs
	Make/O/N=2 wstartp=NaN
	
	wstartp[0]=pcsr(A)
	
	For(i=0;i<num;i+=1)
		kinconcs[i]=Concs[numpnts(Concs)-num+i]
	EndFor
	
	String sw=datum+fc
	String skinconcs=datum+"kinconcs"+fc
	String swstartp=datum+"sp"+fc
	
	Save/J w as sw
	Save/J kinconcs as skinconcs
	Save/J wstartp as swstartp
	
	w+=bla
End

//Returns normalized (against total monomer concentration) concentration of monomers
//1-output = normalizded dimer concentration
Function CalcNormMonomerConcs(C)
	Variable C //Bulk monomer concentration of Ntf2 in Molar
	
	Variable Kd=1e-6 //Kd of dimerization of Ntf2 = 1uM
	
	Return ((-Kd+sqrt(Kd^2+8*C*Kd))/4/C)
End

Function MultiTag()
	
	Wave w=$(stringbykey("TNAME",CsrInfo(A)))
	Wave Times
	Wave Concs
	Variable/G DCRate
	Variable i
	String sname="", stag=""
	For(i=0;i<numpnts(Concs);i+=1)
		sname="text"+num2str(i)
		sprintf stag, "\\Zr050%3.1f M ",Concs[i]*1e6
		if(concs[i]*1e6<1)
		 sprintf stag, "\\Zr050%3.1f nM ",Concs[i]*1e9
		 endif
		 if(mod(i,2))
		Tag/C/N=$sname/X=0.00/Y=15 $nameofwave(w), Times[i][1]-300, stag
		else
				Tag/C/N=$sname/X=0.00/Y=25 $nameofwave(w), Times[i][1]-300, stag
		endif
	EndFor
End

Function KillTags()
	Wave Concs
	variable i
	string sname=""
For(i=0;i<numpnts(Concs);i+=1)
		sname="text"+num2str(i)
		Tag/K/N=$sname
	EndFor
End


Function/WAVE SoftDriftCorrection(num,[w])
	Variable num //number of BSA injections start with 0
	Wave w //wave to correct
	
	Variable delta=40 //seconds for BSA injection
	
	Variable startfit=14771
	Variable endfit=NaN
	
	Wave Times
	Wave/T wDataRef
	
	Variable/G DCRate
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return $""
	endif
	
	
	Variable i
	
	If(paramisdefault(w))
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	
	Prompt i, "Select DataWave", popup sMenuList
	DoPrompt "Select DataWave",i
	
	Wave wData=$(wDataRef[i+6])
	
	else
	
	Wave wData=w
	
	EndIf
	
	Wave wBSATimes=GetBSATimesSimple()
	
	endfit=(wBSATimes[num][2]+delta)*DCRate
	
	Duplicate/o wData $(nameofwave(wData)+"mask"), $(nameofwave(wData)+"sbfit"), $(nameofwave(wData)+"sbcorr")
	
	Wave mask=$(nameofwave(wData)+"mask")
	Wave sbfit=$(nameofwave(wData)+"sbfit")
	Wave sbcorr=$(nameofwave(wData)+"sbcorr")
	
	mask=1
	
	For(i=0;i<num+1;i+=1)
		mask[wBSATimes[i][0]*DCRate,(wBSATimes[i][2]+40)*DCRate]=0
	EndFor
	
	CurveFit/X=1/NTHR=0 dblexp_XOffset  wData[startfit,endfit] /M=mask /D
	
	wave w_coef
	
	sbfit[]=dblexpo(w_coef,x)
	sbcorr-=sbfit
	
	return sbcorr

End

Function dblexpo(w,x) : FitFunc
	Wave w
	Variable x

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(x) = k0+k1*exp(-(x)/k2)+k3*exp(-(x)/k4)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ x
	//CurveFitDialog/ Coefficients 6
	//CurveFitDialog/ w[0] = k0
	//CurveFitDialog/ w[1] = k1
	//CurveFitDialog/ w[2] = k2
	//CurveFitDialog/ w[3] = k3
	//CurveFitDialog/ w[4] = k4


	return w[0]+w[1]*exp(-(x-0.1)/w[2])+w[3]*exp(-(x-0.1)/w[4])
End

Function ExportHeightsZilman(str,volNTR,num)
	String str //String for wave name which gets exportet, e.g. "130820" results in Concs130820
	Variable volNTR //volume of ntf2, kap etc in nm^3 (e.g. ntf = 125)
	Variable num //if num=1, data cells are 2 and 4.
	
	String ssolvolfrac="SolVolFrac"+str
	
	String sHeight41="RelHeight41"+str
	String sHeight31="RelHeight31"+str
	
	String sHeight21="RelHeight21"+str
	
	Wave ConcsForHeight
	If(!waveexists(ConcsForHeight))
		print "ConcsForHeight does not exist!"
		return -1
	EndIf
	
	Duplicate/O ConcsForHeight $ssolvolfrac
	Wave wC=$ssolvolfrac
	wC=ConcsForHeight*6.022e23*volNTR/1e24
	
	variable temp
	
	Duplicate/O root:EMerged:BSAFC4vsFC1:AvgHeight $sHeight41
	Wave wh41=$sHeight41
	if(wh41[0]<wh41[1])
		temp=wh41[1]
	else
		temp=wh41[0]
	endif
		wh41/=temp
	
	If(num==1)
		Duplicate/O root:EMerged:BSAFC2vsFC1:AvgHeight $sHeight21
		Wave wh21=$sHeight21
		if(wh21[0]<wh21[1])
			temp=wh21[1]
		else
			temp=wh21[0]
		endif
		wh21/=temp
	else
		Duplicate/O root:EMerged:BSAFC3vsFC1:AvgHeight $sHeight31
		Wave wh31=$sHeight31
		if(wh31[0]<wh31[1])
			temp=wh31[1]
		else
			temp=wh31[0]
		endif
		wh31/=temp
	
	
	endif

	
	Save/C $ssolvolfrac as (ssolvolfrac+".ibw")
	Save/C wh41 as (sHeight41+".ibw")
	if(num==1)
	Save/C wh21 as (sHeight21+".ibw")

	else
	Save/C wh31 as (sHeight31+".ibw")
	endif
	
//	KillWaves/Z  $sConcs,$sHeight41,$sHeight31,$sHeight42,$sHeight32

End

Function expforkinT(num,datum,fc,man,[cutoff])  //Prepare for interaction map fit in matlab (adds some nonsense to the end and adjusts baseline)
							//export of data and concentration waves to .txt files. 
Variable num //number of injection to start with. begin counting with 0
String datum	//date of the experiment, e.g. "131118"
Variable fc	//number of flow cell, e.g. 4
Variable man	// if wave of cursor A should be exported, man = 1 (fc2), = 2 (fc3), = 3 (fc4). else man=0!
Variable cutoff //how many injections to cut off at the end of the data before export (start counting with 0!)

	Variable/G DCRate

	Wave/T wDataRef
	
	Variable i
	Variable wpos
	
	If(man==0)
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	
	Prompt i, "Select DataWave", popup sMenuList
	DoPrompt "Select DataWave",i
	
	Wave wd=$(wDataRef[i+6])
	wpos=i
	elseif(man==1)
	Wave wd=$(stringbykey("TNAME",CsrInfo(A)))
	wpos=1
	elseif(man==2)
	Wave wd=$(stringbykey("TNAME",CsrInfo(A)))
	wpos=2
	elseif(man==3)
	Wave wd=$(stringbykey("TNAME",CsrInfo(A)))
	wpos=3
	else
	print "man is not set properly!"
	return -1
	endif
	
	//load waves from experiment
	Wave Times
	Wave Concs
								//Wave "Times"
								//Contains all time points for association and dissociation of 
								//single injections.
								//StartAssLog;StartDissLog;EndDissLog;
								//StartAssCalc for each FC (3);StartDissCalc for each FC (3);
								
	Variable cutend=NaN
	
	if(!paramisdefault(cutoff))
		cutend=Times[(dimsize(Times,0)-cutoff)][0]*DCRate
		cutoff+=1
	else
		cutend=(numpnts(wd)-1)
		cutoff=0
	endif
	
	
	//duplicate data wave 
	duplicate/FREE/O/R=[0,cutend-100] wd w
		
	//append some junk to the end of the data wave
	Variable junk=w[numpnts(w)-2]
	Redimension/N=(numpnts(w)+1100) w
	For(i=numpnts(w)-1101;i<numpnts(w);i+=1)
		w[i]=junk
	EndFor
	

	
	//Make waves for export
	Make/O/N=((dimsize(Times,0)-num-cutoff)) kinconcs
	Make/O/N=2 wstartpoint
	Make/O/N=((dimsize(Times,0)-num-cutoff)) wtd,wta
	
	//fill concentration wave for export
	For(i=0;i<(dimsize(Times,0)-num-cutoff);i+=1)
		kinconcs[i]=Concs[num+i]
	EndFor
	
	//write start point wave
	
	wstartpoint[0]=Times[num][wpos+2]
	wstartpoint[0]=floor(wstartpoint[0]*10)
	
	//baseline correction
	Variable Ystart=w[wstartpoint[0]]
	w-=Ystart 
		
	//fill with association times
	
	For(i=0;i<(dimsize(Times,0)-num-cutoff);i+=1)
		wta[i]=Times[num+i][wpos+5]-Times[num+i][wpos+2] 	//startdisscalc - startasscalc
	EndFor
	
	//fill with dissociation times
	For(i=0;i<(dimsize(Times,0)-num-1-cutoff);i+=1)
		wtd[i]=Times[num+i+1][wpos+2]-Times[num+i][wpos+5] 	//startasscalc i+1 - startdisscalc i
	EndFor
	
	wtd[numpnts(wtd)-1]=wtd[numpnts(wtd)-2]
	
	//names for exported waves
	String sw=datum+"FC"+num2str(fc)
	String skinconcs=datum+"kinconcs"+"FC"+num2str(fc)
	String swstartpoint=datum+"sp"+"FC"+num2str(fc)
	String swtd=datum+"td"+"FC"+num2str(fc)
	String swta=datum+"ta"+"FC"+num2str(fc)
	
	//round times to 10Hz
	
	wta=round(wta*10)
	wtd=round(wtd*10)
	
	//export waves for kinetics
	Save/J w as sw
	Save/J kinconcs as skinconcs
	Save/J wstartpoint as swstartpoint
	Save/J wtd as swtd
	Save/J wta as swta
	
	//reverse baseline correction
	w+=Ystart
End

Function ExtractBSAPeaksForDisNorm()

Wave BSATimes=:BSAFC4vsFC1:BSATimes
Wave BSAAmpRef=:BSAFC4vsFC1:AvgBSAPeakAmpRef
Wave SPRFC4

Variable i

Variable numBSA=dimsize(BSATimes,0)

String wnamebase="wBSAInject"
String wname=""

Variable start,ende,temp,j

For(i=0;i<numBSA;i+=1)

	start=BSATimes[i][0]*10-300
	ende=BSATimes[i][2]*10+600
	
	Make/O/D/N=(ende-start+1) baseline
	Setscale/P x,0,0.1,baseline
	wname=wnamebase+num2str(i)
	
	Duplicate/O/R=[start,ende] SPRFC4 $wname
	
	
	Wave w=$wname
	
	Setscale/P x,0,0.1, w
	
	
	
	temp=w[0]
	w-=temp
	
	w/=BSAAmpRef[i]
	
	baseline[]=w[numpnts(w)-1]/numpnts(w)*p
	w-=baseline

EndFor


End

Function ExpAllForHeight(str,fc,[num,delta])
String str
Variable fc //flow-cell for reference (e.g. 1 or 2)
Variable num //number of bsa injections of drift correction for analyte bound export.
Variable delta //points for baseline noise for immobilization calc. default=1000.

Variable/G DCRate

String swout="Data"+str

DFREF saveDFR = GetDataFolderDFR()

Wave Concsforheight

Make/O/D/N=(numpnts(concsforheight),19) $swout
Wave wout=$swout

//Concs
wout[][0] = ConcsforHeight[p]

//Ligand bound and Ligand bound Stdev
SetDataFolder root:Ec1

Wave SPRFC4
Wave SPRFC3

Variable Baseline, BaselineError
Variable Bound, BoundError

Variable startp,ende

if(pcsr(A) < pcsr(B))
startp=pcsr(A)
ende=pcsr(B)
else
startp=pcsr(B)
ende=pcsr(A)
endif
variable d
If(!paramisdefault(delta))

d=delta

else

d=1000
endif

Wavestats/Q/R=[0,d]  SPRFC4 //1120
Baseline=V_avg
BaselineError=V_sdev
Wavestats/Q/R=[startp,ende] SPRFC4 //38115,38825
Bound=V_avg
BoundError=V_sdev

wout[][1] = Bound-Baseline
wout[][2] = sqrt(BaselineError^2+BoundError^2)

Wavestats/Q/R=[0,d]  SPRFC3 //1120
Baseline=V_avg
BaselineError=V_sdev
Wavestats/Q/R=[startp,ende] SPRFC3 //38115,38825
Bound=V_avg
BoundError=V_sdev

wout[][3] = Bound-Baseline
wout[][4] = sqrt(BaselineError^2+BoundError^2)

//Analyte bound
SetDataFolder saveDFR
Wave/T wDataRef
Wave sup=$(wDataRef[3])	//SPRFC3

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

Wave wBSATimes
If(!waveexists(wBSATimes))
	Wave wBSATimes=GetBSATimesSimple()
Endif

Variable k
	
Variable start
	
Variable diff
diff=wBSATimes[1]/2
	
if(wBSATimes[0]*1.5<diff)
	start=1
	else
	start=0
endif

Make/O/D/N=2 boundtemp
	
For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][5] = V_avg
	wout[k][6] = V_Sdev 
		
EndFor

Wave sup=$(wDataRef[4])	//SPRFC4

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][7] = V_avg
	wout[k][8] = V_Sdev 
		
EndFor

//Height

	GetBSATimes(numData=4,numRef=1,disp=0)
	GetBSATimes(numData=3,numRef=1,disp=0)
	
	GetBSATimes(numData=4,numRef=2,disp=0)
	GetBSATimes(numData=3,numRef=2,disp=0)
	
	String swh41="root:EMerged:BSAFC4vsFC1:AvgHeight"
	String swh42="root:EMerged:BSAFC4vsFC2:AvgHeight"
	String swh31="root:EMerged:BSAFC3vsFC1:AvgHeight"
	String swh32="root:EMerged:BSAFC3vsFC2:AvgHeight"
	String swh41error="root:EMerged:BSAFC4vsFC1:AvgHeightError"
	String swh42error="root:EMerged:BSAFC4vsFC2:AvgHeightError"
	String swh31error="root:EMerged:BSAFC3vsFC1:AvgHeightError"
	String swh32error="root:EMerged:BSAFC3vsFC2:AvgHeightError"
	
	String sDataAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpData"
	String sDataAmp42="root:EMerged:BSAFC4vsFC2:AvgBSAPeakAmpData"
	String sDataAmp31="root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpData"
	String sDataAmp32="root:EMerged:BSAFC3vsFC2:AvgBSAPeakAmpData"
	String sDataAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpDataError"
	String sDataAmp42error="root:EMerged:BSAFC4vsFC2:AvgBSAPeakAmpDataError"
	String sDataAmp31error="root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpDataError"
	String sDataAmp32error="root:EMerged:BSAFC3vsFC2:AvgBSAPeakAmpDataError"
	
	String sRefAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp42="root:EMerged:BSAFC4vsFC2:AvgBSAPeakAmpRef"
	String sRefAmp31="root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp32="root:EMerged:BSAFC3vsFC2:AvgBSAPeakAmpRef"
	String sRefAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRefError"
	String sRefAmp42error="root:EMerged:BSAFC4vsFC2:AvgBSAPeakAmpRefError"
	String sRefAmp31error="root:EMerged:BSAFC3vsFC1:AvgBSAPeakAmpRefError"
	String sRefAmp32error="root:EMerged:BSAFC3vsFC2:AvgBSAPeakAmpRefError"
	
	If(fc==1)

	Wave wh41=$swh41
	Wave wh31=$swh31
	Wave wh41error=$swh41error
	Wave wh31error=$swh31error
	Wave RefAmp41=$sRefAmp41
	Wave DataAmp41=$sDataAmp41
	Wave DataAmp31=$sDataAmp31
	Wave RefAmp41error=$sRefAmp41error
	Wave DataAmp41error=$sDataAmp41error
	Wave DataAmp31error=$sDataAmp31error

	elseif(fc==2)
	
	Wave wh41=$swh42
	Wave wh31=$swh32
	Wave wh41error=$swh42error
	Wave wh31error=$swh32error
	Wave RefAmp41=$sRefAmp42
	Wave DataAmp41=$sDataAmp42
	Wave DataAmp31=$sDataAmp32
	Wave RefAmp41error=$sRefAmp42error
	Wave DataAmp41error=$sDataAmp42error
	Wave DataAmp31error=$sDataAmp32error
	
	else
	
	print "wrong flow-cell for reference!"
	
	return -1
	
	endif


wout[][9] = wh31[p]
wout[][10] = wh31error[p]
wout[][11] = wh41[p]
wout[][12] = wh41error[p]
wout[][13] = DataAmp31[p]
wout[][14] = DataAmp31error[p]
wout[][15] = DataAmp41[p]
wout[][16] = DataAmp41error[p]
wout[][17] = RefAmp41[p]
wout[][18] = RefAmp41error[p]

Save/C wout as (swout+".ibw")

End

Function ExpAllForHeightComp(str,fc,[num,delta,datapnts])
String str
Variable fc //flow-cell for reference (e.g. 1 or 2)
Variable num //number of bsa injections of drift correction for analyte bound export.
Variable delta //points for baseline noise for immobilization calc. default=1000.
Variable datapnts //if no concentrations for height meas exists enter points of height measurements

Variable/G DCRate

String swout="Data"+str

DFREF saveDFR = GetDataFolderDFR()

Wave Concsforheight

variable dpnts=NaN

If(!paramisdefault(datapnts))

dpnts=datapnts

else
	if(exists("Concsforheight"))
dpnts=numpnts(concsforheight)
else

print "no concsforheight wave, specify datapoints with variable datapnts"

return -1
endif
endif

Make/O/D/N=(dpnts,19) $swout
Wave wout=$swout

//Concs
If(exists("ConcsforHeight"))
wout[][0] = ConcsforHeight[p]

else 

wout[][0] = NaN

Endif



//Analyte bound
SetDataFolder saveDFR
Wave/T wDataRef
Wave sup=$(wDataRef[2])	//SPRFC2

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

Wave wBSATimes
If(!waveexists(wBSATimes))
	Wave wBSATimes=GetBSATimesSimple()
Endif

Variable k
	
Variable start
	
Variable diff
diff=wBSATimes[1]/2
	
if(wBSATimes[0]*1.5<diff)
	start=1
	else
	start=0
endif

Make/O/D/N=2 boundtemp
	
For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][5] = V_avg
	wout[k][6] = V_Sdev 
		
EndFor

Wave sup=$(wDataRef[4])	//SPRFC4

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][7] = V_avg
	wout[k][8] = V_Sdev 
		
EndFor

//Height

	GetBSATimes(numData=4,numRef=1,disp=0)
	GetBSATimes(numData=2,numRef=1,disp=0)

	
	String swh41="root:EMerged:BSAFC4vsFC1:AvgHeight"
	String swh21="root:EMerged:BSAFC2vsFC1:AvgHeight"
	String swh41error="root:EMerged:BSAFC4vsFC1:AvgHeightError"
	String swh21error="root:EMerged:BSAFC2vsFC1:AvgHeightError"
	
	String sDataAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpData"
	String sDataAmp21="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpData"
	String sDataAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpDataError"
	String sDataAmp21error="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpDataError"
	
	String sRefAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp21="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRefError"
	String sRefAmp21error="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpRefError"
	
	If(fc==1)

	Wave wh41=$swh41
	Wave wh21=$swh21
	Wave wh41error=$swh41error
	Wave wh21error=$swh21error
	Wave RefAmp41=$sRefAmp41
	Wave DataAmp41=$sDataAmp41
	Wave DataAmp21=$sDataAmp21
	Wave RefAmp41error=$sRefAmp41error
	Wave DataAmp41error=$sDataAmp41error
	Wave DataAmp21error=$sDataAmp21error

	elseif(fc==2)
	
	return -1
	
	else
	
	print "wrong flow-cell for reference!"
	
	return -1
	
	endif


wout[][9] = wh21[p]
wout[][10] = wh21error[p]
wout[][11] = wh41[p]
wout[][12] = wh41error[p]
wout[][13] = DataAmp21[p]
wout[][14] = DataAmp21error[p]
wout[][15] = DataAmp41[p]
wout[][16] = DataAmp41error[p]
wout[][17] = RefAmp41[p]
wout[][18] = RefAmp41error[p]

Save/C wout as (swout+".ibw")

End

Function ExpAllForHeightNtf2Kap(str,fc,[num,delta]) //this exports everything for Ntf2 on Kap experiments (only kap stuff).
String str
Variable fc //flow-cell for reference (e.g. 1 or 2)
Variable num //number of bsa injections of drift correction for analyte bound export.
Variable delta //points for baseline noise for immobilization calc. default=1000.

Variable/G DCRate

String swout="Data"+str

DFREF saveDFR = GetDataFolderDFR()

Wave Concsforheight

Make/O/D/N=(numpnts(concsforheight),19) $swout
Wave wout=$swout

//Concs
wout[][0] = ConcsforHeight[p]

//Ligand bound and Ligand bound Stdev
//SetDataFolder root:Ec1

Wave SPRFC4=root:Ec2:SPRFC4
Wave SPRFC2=root:Ec1:SPRFC2

Variable Baseline, BaselineError
Variable Bound, BoundError

Variable startp,ende

if(pcsr(A) < pcsr(B))
startp=pcsr(A)
ende=pcsr(B)
else
startp=pcsr(B)
ende=pcsr(A)
endif
variable d
If(!paramisdefault(delta))

d=delta

else

d=1000
endif

Wavestats/Q/R=[0,d]  SPRFC4 //1120
Baseline=V_avg
BaselineError=V_sdev
Wavestats/Q/R=[startp,ende] SPRFC4 //38115,38825
Bound=V_avg
BoundError=V_sdev

wout[][1] = Bound-Baseline
wout[][2] = sqrt(BaselineError^2+BoundError^2)

Wavestats/Q/R=[0,d]  SPRFC2 //1120
Baseline=V_avg
BaselineError=V_sdev
Wavestats/Q/R=[startp,ende] SPRFC2 //38115,38825
Bound=V_avg
BoundError=V_sdev

wout[][3] = Bound-Baseline
wout[][4] = sqrt(BaselineError^2+BoundError^2)

//Analyte bound
SetDataFolder saveDFR
Wave/T wDataRef
Wave sup=$(wDataRef[2])	//SPRFC2

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

Wave wBSATimes
If(!waveexists(wBSATimes))
	Wave wBSATimes=GetBSATimesSimple()
Endif

Variable k
	
Variable start
	
Variable diff
diff=wBSATimes[1]/2
	
if(wBSATimes[0]*1.5<diff)
	start=1
	else
	start=0
endif

Make/O/D/N=2 boundtemp
	
For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][5] = V_avg
	wout[k][6] = V_Sdev 
		
EndFor

Wave sup=$(wDataRef[4])	//SPRFC4

If(!paramisdefault(num))
 Wave wData=SoftDriftCorrection(num,w=sup)
else
Wave wData=sup
endif

For(k=start;k<dimsize(wBSATimes,0);k+=1)

	boundtemp[0] = wData[(wBSATimes[k][0]-2.5)*DCRate]-wData[0]
	boundtemp[1] = wData[(wBSATimes[k][2]+45)*DCRate]-wData[0]
	Wavestats/Q boundtemp
	
	wout[k][7] = V_avg
	wout[k][8] = V_Sdev 
		
EndFor

//Height

	GetBSATimes(numData=4,numRef=1,disp=0)
	GetBSATimes(numData=2,numRef=1,disp=0)
	
	GetBSATimes(numData=4,numRef=3,disp=0)
	GetBSATimes(numData=2,numRef=3,disp=0)
	
	String swh41="root:EMerged:BSAFC4vsFC1:AvgHeight"
	String swh43="root:EMerged:BSAFC4vsFC3:AvgHeight"
	String swh21="root:EMerged:BSAFC2vsFC1:AvgHeight"
	String swh23="root:EMerged:BSAFC2vsFC3:AvgHeight"
	String swh41error="root:EMerged:BSAFC4vsFC1:AvgHeightError"
	String swh43error="root:EMerged:BSAFC4vsFC3:AvgHeightError"
	String swh21error="root:EMerged:BSAFC2vsFC1:AvgHeightError"
	String swh23error="root:EMerged:BSAFC2vsFC3:AvgHeightError"
	
	String sDataAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpData"
	String sDataAmp43="root:EMerged:BSAFC4vsFC3:AvgBSAPeakAmpData"
	String sDataAmp21="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpData"
	String sDataAmp23="root:EMerged:BSAFC2vsFC3:AvgBSAPeakAmpData"
	String sDataAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpDataError"
	String sDataAmp43error="root:EMerged:BSAFC4vsFC3:AvgBSAPeakAmpDataError"
	String sDataAmp21error="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpDataError"
	String sDataAmp23error="root:EMerged:BSAFC2vsFC3:AvgBSAPeakAmpDataError"
	
	String sRefAmp41="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp43="root:EMerged:BSAFC4vsFC3:AvgBSAPeakAmpRef"
	String sRefAmp21="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpRef"
	String sRefAmp23="root:EMerged:BSAFC2vsFC3:AvgBSAPeakAmpRef"
	String sRefAmp41error="root:EMerged:BSAFC4vsFC1:AvgBSAPeakAmpRefError"
	String sRefAmp43error="root:EMerged:BSAFC4vsFC3:AvgBSAPeakAmpRefError"
	String sRefAmp21error="root:EMerged:BSAFC2vsFC1:AvgBSAPeakAmpRefError"
	String sRefAmp23error="root:EMerged:BSAFC2vsFC3:AvgBSAPeakAmpRefError"
	
	If(fc==1)

	Wave wh41=$swh41
	Wave wh21=$swh21
	Wave wh41error=$swh41error
	Wave wh21error=$swh21error
	Wave RefAmp41=$sRefAmp41
	Wave DataAmp41=$sDataAmp41
	Wave DataAmp21=$sDataAmp21
	Wave RefAmp41error=$sRefAmp41error
	Wave DataAmp41error=$sDataAmp41error
	Wave DataAmp21error=$sDataAmp21error

	elseif(fc==3)
	
	Wave wh41=$swh43
	Wave wh21=$swh23
	Wave wh41error=$swh43error
	Wave wh21error=$swh23error
	Wave RefAmp41=$sRefAmp43
	Wave DataAmp41=$sDataAmp43
	Wave DataAmp21=$sDataAmp23
	Wave RefAmp41error=$sRefAmp43error
	Wave DataAmp41error=$sDataAmp43error
	Wave DataAmp21error=$sDataAmp23error
	
	else
	
	print "wrong flow-cell for reference!"
	
	return -1
	
	endif


wout[][9] = wh21[p]
wout[][10] = wh21error[p]
wout[][11] = wh41[p]
wout[][12] = wh41error[p]
wout[][13] = DataAmp21[p]
wout[][14] = DataAmp21error[p]
wout[][15] = DataAmp41[p]
wout[][16] = DataAmp41error[p]
wout[][17] = RefAmp41[p]
wout[][18] = RefAmp41error[p]

Save/C wout as (swout+".ibw")

End
