#pragma rtGlobals=3		// Use modern global access method and strict wave access.

//This is the main procedure of the spr-auswertung procs. You only have to load this. All important
//parameters have to be set in here!

//Only working for 10ul/min flow


#include ":FileLoaderLarisa"	//Contains Functions used for spr data file loading.
#include ":HelperFunctions"	//Contains small functions to help in analysis and data handling.
#include ":GetBindingCurves"
#include ":DataPrep"
#include ":SimpleOnFitting"
#include ":SimpleOffFitting"
#include ":SchochProc"
#include ":BaseLineCorrection"
#include ":MergeExperiments"

Variable V_fitOptions = 4	//suppress progress window
Variable V_FitError = 0 //prevent abort on error

Menu "SPR Analysis"
//	"Load and Prepare/1",/Q,DoAll()
	"Load Experiment/1",/Q,LoadDataFile()
	"Load Sample Name and Concentration",/Q,LoadSamplesFile()
	"Choose Working Folder",/Q,ChooseActiveDF(1)
	"Prepare Data",/Q,PrepareData()
	Submenu "Other Functions"
		"Restore Original Data",/Q,restore()
		"GetTimes",/Q,GetTimes()
		"Review Times",/Q,ReviewTimes()
		"Simple Equilibrium Fit",/Q,SimpleOnFit()		
		"Simple Off Fit",/Q,SimpleOffFit()
		"Merge two Experiments/2",/Q,MergeExperiments()
		"Check for BSA binding",/Q,ExtractBSABinding()
	End
	Submenu "Schoch"
		"Calculate Heights from BSA injections",/Q,GetBSATimes()
	End
End
	
Function DoAll()	//some problems with timing
	LoadDataFile()
	PrepareData()
	GetTimes()
End