#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function MergeExperiments([path1,path2,Fname])
	String path1, path2, Fname
	
	Wave/T exps=root:ExperimentList
	
	String e1
	String e2
	If(!ParamIsDefault(path1) && !ParamIsDefault(path2))
		e1=path1
		e2=path2
	else
		e1=ChooseActiveDF(0)
		e2=ChooseActiveDF(0)
	EndIf
	
	Wave/T wDataRef1=$(e1+":wDataRef")
	Wave/T wDataRef2=$(e2+":wDataRef")

	String ename
	If(!ParamIsDefault(Fname))
		ename=Fname
	else
		Prompt ename, "Experiment Folder Name (e.g Experiment Date)"
		DoPrompt "Give Foldername...",ename
		if (V_Flag)
			Print "Need Foldername"
			return -1	// User canceled
		endif
	endif
	
	String sNewDataFolder="root:E"+ename
	NewDataFolder/O/S $sNewDataFolder	//Create new Data Folder in root and make it active
	
	
	Redimension/N=(dimsize(exps,0)+1,-1) exps
	
	exps[(dimsize(exps,0)-1)][%Folder]=ename
	exps[(dimsize(exps,0)-1)][%Name]=e1+"+"+e2
	
	Wave wT1=$(e1+":"+wDataRef1[0])
	Variable/G gToffset=wT1[numpnts(wT1)-1]
	
	Wave weventT2=$(e2+":"+wDataRef1[6])
	Wave weventT1=$(e1+":"+wDataRef1[6])
	Make/FREE/D/N=(numpnts(weventT2)) eventTloc2=weventT2
	eventTloc2+=gToffset
	Concatenate/NP {weventT1,eventTloc2},eventT
		
	Variable i
	String wavelistStr
	String wdest
	For(i=0;i<6;i+=1)
		wavelistStr=e1+":"+wDataRef1[i]+";"+e2+":"+wDataRef1[i]+";"
		wdest=wDataRef1[i]
		Concatenate/NP wavelistStr, $wdest
	EndFor
	
	Wave c1=$(e1+":Concs")
	Wave c2=$(e2+":Concs")
	
	if(exists(e1+":Concs")&&exists(e2+":Concs"))
		Concatenate/NP {c1,c2}, Concs
	endif
	
	Wave wTloc=$wDataRef1[0]
	wTloc[numpnts(wT1),numpnts(wTloc)-1]+=wT1[numpnts(wT1)-1]
	
	Duplicate wDataRef1 wDataRef

	Variable/G DCRate=CheckDCRate(wTloc)
	exps[(dimsize(exps,0)-1)][%DCRate]=num2str(DCRate)
	
	
	Variable/G gPoffset=numpnts(wT1)
	
	
End


Function MergeAllSorted()
	
	//Merge all folders only when folders are ordered in names
	
	SetDataFolder root:
	
	String  sfolders= StringbyKey("FOLDERS",datafolderdir(1),":",";")
	
	MergeExperiments(path1=("root:"+stringfromlist(0,sfolders,",")),path2=("root:"+stringfromlist(1,sfolders,",")),Fname="Merge12")

	
	Variable i
	
	String E1,E2,name
	
	E1="root:EMerge12"
	
	For(i=2;i<(itemsinlist(sfolders,","));i+=1)	
		
		name="Merge1"+num2str(i+1)
		
		E2="root:"+stringfromlist(i,sfolders,",")
		
		print "Merge:",E1,E2,name
			
		MergeExperiments(path1=E1,path2=E2,Fname=name)	
		
		If(i<(itemsinlist(sfolders,",")))
			KillDataFolder/Z E1
		EndIf
			
		E1="root:E"+name		
	EndFor
End