#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function SimpleOnFit()

	ChooseActiveDF(1)	//Choose Experiment
	Variable/G gDrift
	Variable/G gOffsetBind
	Variable/G gRepeat=0
	ChooseActiveFCDF(1)	//Choose Flow Cell

	NewDataFolder/O Fits
	
	//List all waves in folder
	Wave/T wRef	//Contains all relevant wave names
	Variable i
	Wave wt=$("::Times")
	Wave c=$("::Concs")
	Wave/T ConcsT
	If(!waveexists(ConcsT))
		Make/T/N=(numpnts(c)) ConcsT
		ConcsT[]=num2str(c[p])
	EndIf
	
	//Display all waves in folder
	//DoWindow/K res
	Display/K=1/N=res $wRef[0]
	String wName="res"
	For(i=1;i<numpnts(wRef);i+=1)	//wRef[0] already displayed before
		AppendToGraph/W=$wName $wRef[i]
	EndFor
	Legend/W=$wName/C/N=text0/A=RT
	ShowInfo/CP=0/W=$wName
	SetAxis bottom,0,rightx($wRef[1])*2
	Cursor/A=1 A $wRef[numpnts(wRef)-1] wt[0][1]-wt[0][0]-4
	
	
	//Panel to choose fitting parameters and start fit
	Make/D/O/N=(numpnts(wRef)) swave=1,swave2=0
	
	//Create reference wave for indiviudal fitting parameter sets W_CoeffX
	Wave W_coef
	Make/WAVE/O/N=(numpnts(wRef)) wFitCoefREF=W_coef
	
	//////temp hack////
	swave=0
	swave2=1
	For(i=0;i<9;i+=1)
		swave2[i]=0
	EndFor
	
	
	///////
	
	DoWindow/K sfit
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1/N=sfit /W=(650,64,1600,674)
	SetDrawLayer UserBack
	SetDrawEnv fsize=20
	DrawText 46,31,"Choose End Point of Fit First!!"
	SetDrawEnv fsize=20
	DrawText 384,47,"Choose Curves to Fit"
	SetDrawEnv fsize=15
	DrawText 600,47,"Take Marker Value for Req"
	SetDrawEnv fsize=15
	DrawText 816,47,"Concs"
	Button bn1,pos={284,528},size={239,67},proc=startfit,title="Start Fitting!"
	Button bn1,font="Arial Greek",fSize=20,fColor=(0,39168,19712)
	Button bn2,pos={153,207},size={150,60},proc=checkfit,title="Check Parameters"
	Button bn2,font="Arial Greek",fSize=15,fColor=(0,39168,19712)
	SetVariable sv1,pos={50,50},size={150,20},title="kobs1",font="Arial Greek"
	SetVariable sv1,fSize=15,value= _NUM:0.57
	SetVariable sv2,pos={50,100},size={150,20},title="kobs2",font="Arial Greek"
	SetVariable sv2,fSize=15,value= _NUM:0.0475	
	SetVariable sv3,pos={50,150},size={150,20},title="kobs3",font="Arial Greek"
	SetVariable sv3,fSize=15,value= _NUM:0.00465
	SetVariable sv4,pos={220,50},size={150,20},title="Req1",font="Arial Greek"
	SetVariable sv4,fSize=15,value= _NUM:207
	SetVariable sv5,pos={220,100},size={150,20},title="Req2",font="Arial Greek"
	SetVariable sv5,fSize=15,value= _NUM:330
	SetVariable sv6,pos={220,150},size={150,20},title="Req3",font="Arial Greek"
	SetVariable sv6,fSize=15,value= _NUM:813
	SetVariable sv10,pos={50,300},size={150,20},title="KD1",font="Arial Greek"
	SetVariable sv10,fSize=15,value= _NUM:10e-6
	SetVariable sv11,pos={50,350},size={150,20},title="KD2",font="Arial Greek"
	SetVariable sv11,fSize=15,value= _NUM:100e-6
	ListBox lb1,pos={384,56},size={150,300},fSize=15,mode=4,listWave=wRef,SelWave=swave,proc=selector
	ListBox lb2,pos={600,56},size={150,300},fSize=15,mode=4,listWave=wRef,SelWave=swave2
	ListBox lb3,pos={816,56},size={100,300},fSize=15,mode=0,listWave=ConcsT
	CheckBox cb1,mode=1,pos={50,500},title="Correct for BSA binding",font="Arial Greek"
	CheckBox cb2,mode=1,pos={50,520},title="Correct for BSA drop",font="Arial Greek"
	CheckBox cb3,mode=1,pos={50,480},title="Correct BaseLineDrift",font="Arial Greek"
	CheckBox cb4,mode=1,pos={50,460},title="Normalize by LI2",font="Arial Greek"
	CheckBox cb5,mode=1,pos={50,440},title="Offset",font="Arial Greek"
	SetVariable sv7,pos={220,480},size={150,20},title="Drift/h",font="Arial Greek"
	SetVariable sv7,fSize=15,value=gDrift
	SetVariable sv8,pos={220,440},size={150,20},title="Offset",font="Arial Greek"
	SetVariable sv8,fSize=15,value=gOffsetBind
	SetVariable sv9,pos={420,440},size={250,20},title="Repeat every seconds",font="Arial Greek"
	SetVariable sv9,fSize=15,value=gRepeat
End

Function startfit (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	Variable/G gOffsetBind
	Variable/G gRepeat
	Wave Times
	SetDataFolder sref
		
	Variable Pendfit=pcsr(A)
	String wName=csrwave(A)
	Wave w=$wName
	Wave swave	//containts wave ref for waves selected for fit
	
	Variable numrepeats=floor((numpnts(w)-1-Pendfit)/(DCrate*10)/gRepeat)
	
	If(gRepeat==0)
		numrepeats=1
	Endif
			

	Variable i
	
	ControlInfo/W=sfit cb1
	Variable BSACorrection=V_value
	
	If(BSACorrection)
		print "Use BSA Correction"
		Wave wBb=BSABinding()
	EndIf
	
	ControlInfo/W=sfit cb2
	Variable BSAdropCorr=V_value
	
	If(BSAdropCorr)
		Wave wBd=BSADrop()
	EndIf
	
	

	ControlInfo/W=sfit sv1
	Variable kobs1=V_value
	ControlInfo/W=sfit sv2
	Variable kobs2=V_value
	ControlInfo/W=sfit sv3
	Variable kobs3=V_value
	ControlInfo/W=sfit sv4
	Variable Req1=V_value
	ControlInfo/W=sfit sv5
	Variable Req2=V_value
	ControlInfo/W=sfit sv6
	Variable Req3=V_value
	Variable A0=w[0]
	ControlInfo/W=sfit sv10
	Variable KD1=V_value
	ControlInfo/W=sfit sv11
	Variable KD2=V_value

	
	Wave/Wave wFitCoefREF
	
	//Make Initial guesses wave
	Make/O/D/N=8 W_coef
	W_coef[0]=Req1
	W_coef[1]=Req2
	W_coef[2]=Req3
	W_coef[3]=kobs1
	W_coef[4]=kobs2
	W_coef[5]=kobs3
	W_coef[6]=0
	W_coef[7]=A0
	
	
	Wave/T wRef	//contains all fit relevant wave names
	Make/T/O/N=0 waves2fit
	Make/WAVE/O/N=0 refcoefwave2fit
	For(i=0;i<numpnts(wRef);i+=1)
		If(swave[i])
			Redimension/N=(numpnts(waves2fit)+1) waves2fit
			Redimension/N=(numpnts(refcoefwave2fit)+1) refcoefwave2fit
			waves2fit[numpnts(waves2fit)-1]=wRef[i]
			refcoefwave2fit[numpnts(refcoefwave2fit)-1]=wFitCoefREF[i]
		EndIf
	EndFor
	
	//Start Fitting
	Make/O/D/N=(numpnts(waves2fit),8) :Fits:fitRes=NaN
	Make/O/D/N=(numpnts(swave)) :Fits:Reqtot=NaN

	Wave res=$(":Fits:fitRes")	//Fit Results wave
	Wave reqtot=$(":Fits:Reqtot")	//Total equilibrium response from fit
	Wave c=$("::Concs")
	
	If(!waveexists(c))
		print "Enter Concentrations of Injections in [M] or load sample concentration list from Menu!"
		Make/D/N=(numpnts(wRef)) ::Concs
		Edit/K=1 ::Concs
		return -1
	EndIf
	Make/O/D/N=0 concs
	For(i=0;i<numpnts(swave);i+=1)
		If(swave[i])
			Redimension/N=(numpnts(concs)+1) concs
			concs[numpnts(concs)-1]=c[i]
		EndIf
	EndFor

//	NewPanel /N=ProgressPanel /W=(285,111,739,193)
//	ValDisplay valdisp0,pos={18,32},size={342,18},limits={0,(numpnts(w)),0},barmisc={0,0}
//	ValDisplay valdisp0,value= _NUM:0
//	ValDisplay valdisp0,mode= 3
//	ValDisplay valdisp0,highColor=(0,65535,0)
//	Button bStop,pos={375,32},size={50,20},title="Stop"
//	DoUpdate /W=ProgressPanel /E=1	// mark this as our progress window
	Variable pos=0
	For(i=0;i<numpnts(waves2fit);i+=1)
	
		//link to w_coef wave
		Wave wcoef=refcoefwave2fit[numpnts(refcoefwave2fit)-1-i]
		//Data Wave to fit to
		Wave wf=$(waves2fit[numpnts(waves2fit)-1-i])
		wcoef[7]=wf[0]
		
		//Make constraints wave for fitting
		Make/O/T wConstraints={"K0 >= 0","K1 >= 0", "K2 >= 0","K3 >= 0","K4 >= 0", "K5 >= 0"}
		
		print "FIT: use coef wave:", nameofwave(wcoef),"use data wave:",nameofwave(wf)
		print wcoef
		
		
		//Fit Data Range using given Fit Function
		FuncFit/W=2/N/Q/L=(numpnts(w))/X/H="00000011"/NTHR=1 AssFit3 wcoef wf[0,Pendfit] /D/R/A=0/C=wConstraints
		///TBOX=857
		
		ModifyGraph rgb($("fit_"+nameofwave(wf)))=(0,0,65280)	//display fit in blue
	
		//Write Fit Results into fitRES wave in Fit Folder
		res[i][0]=wcoef[0]	//Req1
		res[i][1]=wcoef[1]	//Req2
		res[i][2]=wcoef[2]	//Req3
		res[i][3]=wcoef[3]	//kobs1
		res[i][4]=wcoef[4]	//kobs2
		res[i][5]=wcoef[5]	//kobs3
		res[i][6]=wcoef[6]	//t0
		res[i][7]=wcoef[7]	//A0
		
//		ValDisplay valdisp0,value= _NUM:i+1,win=ProgressPanel
//		DoUpdate /W=ProgressPanel

		//Calculate Total equilibrum response from fit results
		Variable j=0
		Do
			j+=1
		While(!swave[(numpnts(swave))-j] && j<(numpnts(swave)-1))	
		swave[(numpnts(swave))-j]=0		
		reqtot[(numpnts(reqtot))-j]=res[i][0]+res[i][1]+res[i][2]+res[i][7]
		
		DoUpdate
	EndFor
//	KillWindow ProgressPanel
//	DoWindow/K sfit	//Kill control window



Variable P=Pendfit
Print "numrepeats",numrepeats
Make/o/d/n=(numrepeats) wKD1out, wKD2out, wTimeOff, wKD11out,wRmax1out,wRmax2out,wRmax11out,wSigmaKD1out,wSigmaKD2out,wSigmaKD11out,wChisqDLI,wChisqLI
Variable counter
For(counter=0;counter<numrepeats;counter+=1) //loop over gRepeat

	DoWindow/K DoubleIsotherm
	DoWindow/K SingleIsotherm
	If(counter>0)
		Wave reqtotbak
		Duplicate/O reqtotbak reqtot
	EndIf
	P=Pendfit+gRepeat*DCRate*10*counter
	//Fill total equilibrium wave with selected "only take value from curve" waves
	Wave swave2
	For(i=0;i<numpnts(swave2);i+=1)
		if(swave2[i])
			Wave g=$wRef[i]
			reqtot[i]=g[P]
		endif
	EndFor
	
	//Correct for BaseLineDrif cb3 sv7
	ControlInfo/W=sfit cb3
	If(V_value)
		Make/O/D/N=(numpnts(swave2)) wBLC=0
		DFREF sdf=GetDataFolderDFR()
		SetDatafolder ::
		Variable/G gDrift //3600
		Variable/G gYDrift=0 //changed because makes no sense together with BSAbinding correction
		Variable/G gSelectedFC
		SetDataFolder sdf
		For(i=0;i<numpnts(wBLC);i+=1)
			wBLC[i]=gYDrift+(gDrift/3600)*(Times[i][gSelectedFC+2]+(P/DCrate/10))
		EndFor
		
		For(i=0;i<numpnts(reqtot);i+=1)
		if(swave2[i])
			reqtot[i]-=wBLC[i]
		endif
		EndFor
		
	EndIf
	
	//Correct for static offset in baseline cb5, sv8
	ControlInfo/W=sfit cb5
	If(V_value)
		reqtot-=gOffsetBind
	EndIf
	
	//Correct for bound BSA
	If(BSACorrection)
		For(i=0;i<numpnts(reqtot);i+=1)
			Wavestats/Q/R=[0,i] wBb
			reqtot[i]-=V_Sum
		EndFor
		Display/K=1 wBb
		ModifyGraph mode=4,marker=42,rgb=(26112,0,0)
		Label left "Signal change upon BSA binding [RU]";DelayUpdate
		Label bottom "Injection number"
		Wavestats/Q/R=[0,numpnts(wBb)-1] wBb
		TextBox/C/N=BSAcorr/A=RT "Total Bound BSA (V_Sum):"+num2str(V_sum)
	EndIf
	
	//Correct for BSA drop
	If(BSAdropCorr)
		For(i=0;i<numpnts(reqtot);i+=1)
			Wavestats/Q/R=[0,i] wBd
			If(V_sum>0)
			reqtot[i]+=V_Sum
			endif
		EndFor
		Display/K=1 wBd
		ModifyGraph mode=4,marker=42,rgb=(26112,0,0)
		Label left "Signal change upon BSA binding [RU]";DelayUpdate
		Label bottom "Injection number"
		Wavestats/Q/R=[0,numpnts(wBd)-1] wBd
		TextBox/C/N=BSAdcorr/A=RT "Total Drop by BSA (V_Sum):"+num2str(V_sum)	
	EndIF
	
	
	//correct concs and reqtot points for affinity fitting
	Make/O/D/N=0 concs
	Make/FREE/D/N=0 temp
	For(i=0;i<numpnts(reqtot);i+=1)
		If(reqtot[i])
			Redimension/N=(numpnts(concs)+1) concs
			Redimension/N=(numpnts(temp)+1) temp
			concs[numpnts(concs)-1]=c[i]
			temp[numpnts(temp)-1]=reqtot[i]
		Endif
	EndFor
	
	Duplicate/O reqtot reqtotbak
	Duplicate/O temp reqtot
	 
//	reverse reqtot	//reverse wave for displaying against concentration wave in increasing order
	
		
	If(numpnts(reqtot) < 5)
		print "DataSet for total equilibrium too small to fit!"
		return -1
	EndIf
	
		
	////Single Component Langmuir Isotherm Fit///////
	Display/N=SingleIsotherm/K=1 reqtot vs concs	//Displays equilibrium response against injected concetration of analyte
	ModifyGraph mode=3,marker=24,msize=5,mrkThick=1.5,rgb=(0,52224,26368)
	Wavestats/Q reqtot
	SetAxis left 0,(V_max*1.5)
	SetAxis bottom 0,((concs[numpnts(concs)-1])*3)
	Legend/C/N=text0 /TR
	
	//Make W_coef for Langmuir isotherm fit
	Make/O/D/N=2 W_coef
	W_coef[0]=reqtot[numpnts(reqtot)-1]*1.5	//Rmax
	W_coef[1]=KD1	//Kd
	
	
	//Fit Langmuir Isotherm
	FuncFit/N/Q/TBOX=857/L=(numpnts(concs)*200)/X/NTHR=1 LI W_coef reqtot /X=concs /D/R/A=0
	Duplicate/O $("fit_"+nameofwave(reqtot)) $("fit_"+nameofwave(reqtot)+"LI")
	RemoveFromGraph $("fit_"+nameofwave(reqtot))
	AppendToGraph $("fit_"+nameofwave(reqtot)+"LI")
	
	Wave W_sigma
	wChisqLI[counter]=V_Chisq
	
	Duplicate/O W_coef bakW_coef_singleLI
	Duplicate/O W_sigma bakW_sigma_singleLI
	
	//Normalize if cb4 is checked
	ControlInfo/W=sfit cb4
	Variable Normalization=V_value
	
	If(Normalization)
		SetAxis left 0,1
	EndIf
	
	////Single Component Langmuir Isotherm Fit End///////
	
	////Double Component Langmuir Isotherm Fit///////
	Display/N=DoubleIsotherm/K=1 reqtot vs concs	//Displays equilibrium response against injected concetration of analyte
	ModifyGraph mode=3,marker=24,msize=5,mrkThick=1.5,rgb=(0,52224,26368)
	Wavestats/Q reqtot
	SetAxis left 0,(V_max*1.5)
	SetAxis bottom 0,((concs[numpnts(concs)-1])*3)
	Legend/C/N=text0 /TR
	
	//Make W_coef for Two component Langmuir isotherm fit
	Make/O/D/N=4 W_coef
	W_coef[0]=reqtot[numpnts(reqtot)-1]*0.6	//Rmax1
	W_coef[1]=reqtot[numpnts(reqtot)-1]*0.3	//Rmax2
	W_coef[2]=KD1	//Kd1
	W_coef[3]=KD2	//Kd2
	
//	Make/o/t/n=4 T_constraints
//	t_constraints[0]={"K0 >= 0","K1 >= 0"}
	
	//Fit Two component Langmuir Isotherm
	FuncFit/N/Q/TBOX=857/L=(numpnts(concs)*200)/X/NTHR=1 LI2 W_coef reqtot /X=concs /D/R/A=0///C=t_constraints
	Duplicate/O $("fit_"+nameofwave(reqtot)) $("fit_"+nameofwave(reqtot)+"LI2")
	RemoveFromGraph $("fit_"+nameofwave(reqtot))
	AppendToGraph $("fit_"+nameofwave(reqtot)+"LI2")
	AppendToGraph $("fit_"+nameofwave(reqtot)+"LI")
	ModifyGraph lstyle($("fit_"+nameofwave(reqtot)+"LI"))=3,rgb($("fit_"+nameofwave(reqtot)+"LI"))=(0,0,65280)
	
	//Normalize if cb4 is checked
	
	wChisqDLI[counter]=V_Chisq
	
	If(Normalization)
		Wave wfitreq=$("fit_"+nameofwave(reqtot)+"LI2")
		Wave wfitreq1=$("fit_"+nameofwave(reqtot)+"LI")
		reqtot/=(W_coef[0]+W_coef[1])
		wfitreq/=(W_coef[0]+W_coef[1])
		wfitreq1/=(W_coef[0]+W_coef[1])
		SetAxis left 0,1
	EndIf
	
	print "P",P
	print "+Time",(P-Pendfit)/DCRate/10
	Print "KD1:",W_coef[2]
	Print "KD2:",W_coef[3]
	print "Kd1_1:",bakW_coef_singleLI[1]
	print "Rmax_1:",bakW_coef_singleLI[0]
	Print "Rmax1:",W_coef[0]
	Print "Rmax2:",W_coef[1]
	Print "Max bound:",W_coef[0]+W_coef[1]
	
	if(W_coef[2]>=0 && W_coef[2]<100e-6)
	wKD1out[counter]=W_coef[2]
	else
	wKD1out[counter]=NaN
	endif
	if(W_coef[3]>=0 && W_coef[3]<500e-6)
	wKD2out[counter]=W_coef[3]
	else
	wKD2out[counter]=NaN
	endif
	wKD11out[counter]=bakW_coef_singleLI[1]
	wTimeOff[counter]=P/DCRate/10
	wRmax1out[counter]=W_coef[0]
	wRmax2out[counter]=W_coef[1]
	wRmax11out[counter]=bakW_coef_singleLI[0]
	wSigmaKD1out[counter]=W_sigma[2]
	wSigmaKD2out[counter]=W_sigma[3]
	wSigmaKD11out[counter]=bakW_sigma_singleLI[1]
	
	
	
//	Wavestats/Q reqtot
//	SetAxis left 0,(V_max*1.5)
//	SetAxis bottom 0,((concs[numpnts(concs)-1])*2)
//	Legend/C/N=text0 /TR
	////Double Component Langmuir Isotherm Fit End///////
	
	
EndFor //Loop over gRepeat
If(gRepeat>0)
	Display/K=1 wKD1out vs wTimeOff; appendtograph wKD2out vs wTimeOff; appendtograph wKD11out vs wTimeOff
	appendtograph/R wrmax1out vs wtimeoff
	appendtograph/R wrmax2out vs wtimeoff
	appendtograph/R wRmax11out vs wtimeoff
	ModifyGraph rgb(wKD2out)=(0,15872,65280),rgb(wKD11out)=(0,39168,0)
	ModifyGraph rgb(wRmax2out)=(0,15872,65280),rgb(wRmax11out)=(0,39168,0)
	ModifyGraph mode=3,marker(wKD1out)=19,marker(wKD2out)=19,marker=0
	ErrorBars wKD11out Y,wave=(wSigmaKD11out,wSigmaKD11out)
	ErrorBars wKD1out Y,wave=(wSigmaKD1out,wSigmaKD1out)
	ErrorBars wKD2out Y,wave=(wSigmaKD2out,wSigmaKD2out)
	ModifyGraph marker(wRmax1out)=8,marker(wRmax2out)=8,marker(wRmax11out)=8
	ModifyGraph zero(right)=4
	Legend/C/N=clusterfk
	Display/K=1 wchisqLI vs wtimeoff; appendtograph wchisqdli vs wtimeoff
	ModifyGraph rgb(wChisqDLI)=(0,12800,52224),mode=3,marker=8
	Legend/C/N=legchisq
EndIf
End

Function checkfit (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	SetDataFolder sref
	
			
	Variable Pendfit=pcsr(A)
	String wName=csrwave(A)
	Wave w=$wName
	
	////////////////////////
	Wave/T wRef
	Wave/Wave wFitCoefREF
	FindValue/TEXT=wName wRef
	Variable wavepos=V_value
	String coefwavename="W_coef"+num2str(wavepos+1)
	
	//////////////////////
	
	
	//Take initial guesses and simulate curve
	String wsim=":Fits:"+nameofwave(w)+"sim"
	make/O/D/N=(numpnts(w)) $wsim
	Wave ws=$wsim
	setscale/I x,leftx(w),rightx(w),"s",ws
	
	ControlInfo/W=sfit sv1
	Variable kobs1=V_value
	ControlInfo/W=sfit sv2
	Variable kobs2=V_value
	ControlInfo/W=sfit sv3
	Variable kobs3=V_value
	ControlInfo/W=sfit sv4
	Variable Req1=V_value
	ControlInfo/W=sfit sv5
	Variable Req2=V_value
	ControlInfo/W=sfit sv6
	Variable Req3=V_value
	Variable A0=w[0]
	
		
	ws[]=A0+Req1*(1-exp(-(kobs1*(p/(dcRate*10)))))+Req2*(1-exp(-(kobs2*(p/(dcRate*10)))))+Req3*(1-exp(-(kobs3*(p/(dcRate*10)))))
	
	Removefromgraph/Z/W=res $nameofwave(ws)
	AppendToGraph/W=res ws
	ModifyGraph rgb($nameofwave(ws))=(0,0,65280)
			
	//Make Initial guesses wave
	Make/O/D/N=8 $coefwavename
	Wave wc=$coefwavename
	wc[0]=Req1
	wc[1]=Req2
	wc[2]=Req3
	wc[3]=kobs1
	wc[4]=kobs2
	wc[5]=kobs3
	wc[6]=0
	wc[7]=A0
	
	wFitCoefREF[wavepos]=wc
	
	print "Set coefficient wave to:", nameofwave(wc)

	
End

Function selector(ctrlName,row,col,event) : ListboxControl
	String ctrlName     // name of this control
	Variable row        // row if click in interior, -1 if click in title
	Variable col        // column number
	Variable event      // event code
	
	wave swave,swave2

	swave2[]=!swave[p]
	
	return 0            // other return values reserved
End

Function/WAVE BSADrop()

	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Wave/T wDataRef
	Variable/G DCRate
	Wave/T wName = $(wDataRef[5])	//Contains Name of event (from logfile)
	Wave wTime = $(wDataRef[6])	//Contains Time of event (from logfile)
	Wave wT=Times
	Variable i
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	Prompt i, "Select DataWave", popup sMenuList
	DoPrompt "Select DataWave for BSA Correction",i
	
	Wave w=$(wDataRef[i+6])
	
	Variable/G gToffset
	Variable/G gPoffset
	
	if(!exists("gToffset"))
		gToffset=0
		gPoffset=0
	endif
	
	SetDataFolder sref
	
	make/D/O/N=(0,3) BSATimes		//It is assumed that a single height measurement
									//is compsed of three BSA injections wrapped in a
									//single Injection Sequence (single cycle kinetics)
	
	//Extract BSA injection Start times from Logfile
	Variable j,k,offset=0,count=0
	Variable delta	//seconds from injection ready to middle of two injections.
	For(i=0;i<(numpnts(wName));i+=1)
	
		If(stringmatch(wname(i),"Flow path:*"))
			offset=count*gToffset
			count+=1
		EndIf
		
		If(stringmatch(wName(i), "Inject sequence: Start*"))
			Redimension /N=(dimsize(BSATimes,0)+1,-1) BSATimes
			k=0
			For(j=i;j<(numpnts(wName));j+=1)	
				If(stringmatch(wName(j),"Inject: Start*"))
					If(k==1)
						delta=wTime[j+1]-wTime[j]
					EndIf
					If(k<3)//Only first 3 BSA injections are taken into calculation
						BSATimes[dimsize(BSATimes,0)-1][k]=wTime[j]//+offset
					//	print "gToffset=",gToffset,"Line=",i,"PeakNumber=",j,"Time=",wTime[j],"offset=",offset,"Out=",wTime[j]+offset
					elseif(k>=3)
						print "More than 3 BSA injections found! ("+num2str(wTime[j])+"seconds"
					EndIf
					k+=1
				Elseif(stringmatch(wName(j),"Inject sequence: Ready*"))
					break
				EndIf
			EndFor
		Endif		
	EndFor
	
	make/D/O/N=0 wBSADrop
	make/D/O/N=(0,24) BSAPeakPos
	
	For(i=0;i<dimsize(BSATimes,0);i+=1)
		Redimension /N=(dimsize(BSAPeakPos,0)+1,-1) BSAPeakPos
		For(j=0;j<3;j+=1)	//change to j=1 to include only last two BSA injections for calc.
			Wave BSATemp=GetBSAPeak((BSATimes[i][j])*Dcrate-2*DcRate,w,delta)
			BSAPeakPos[dimsize(BSAPeakPos,0)-1][j*4]=BSATemp[1]
			BSAPeakPos[dimsize(BSAPeakPos,0)-1][(j*4)+1]=BSATemp[2]
			BSAPeakPos[dimsize(BSAPeakPos,0)-1][(j*4)+2]=BSATemp[3]
			BSAPeakPos[dimsize(BSAPeakPos,0)-1][(j*4)+3]=BSATemp[4]
		EndFor

			Redimension /N=(dimsize(wBSADrop,0)+1,-1) wBSADrop
			If(i==0)
				wBSADrop[numpnts(wBSADrop)-1]=w[0]-w[BSAPeakPos[i][2]]
				print nameofwave(w),w[0],w[BSAPeakPos[i][2]],BSAPeakPos[i][2]
				
			else
				wBSADrop[numpnts(wBSADrop)-1]=w[wT[i-1][2]*Dcrate]-w[BSAPeakPos[i][2]]
			endif

	EndFor
	return wBSADrop
End


Function/WAVE BSABinding()
		
	DFREF sref=GetDataFOlderDFR()
	
	SetDataFolder ::
	
	Wave Times
	Wave/T wDataRef
	Variable/G DCRate
	
	if(!exists("Times"))
		print "Missing wTimes: Use GetTimes Function first!"
		return Times
	endif
	
	Variable i
	String sMenuList=""
	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	Prompt i, "Select DataWave", popup sMenuList
	DoPrompt "Select DataWave for BSA Correction",i
	
	Wave w=$(wDataRef[i+6])
	
	SetDataFolder sref
		

	For(i=0;i<3;i+=1)
		sMenuList+=wDataRef[i+7]+";"
	EndFor
	
	Make/O/D/N=(dimsize(Times,0)) wBSAbound
	
	Variable k
	For(k=0;k<dimsize(Times,0);k+=1)
		if(k==0)
			wBSAbound[k]=w[(Times[k][0]-60)*DCRate]-w[0]
		else
			wBSAbound[k]=w[(Times[k][0]-60)*DCRate]-w[Times[k-1][2]*DCRate]
		endif
	EndFor
	
	For(k=0;k<dimsize(Times,0);k+=1)
		if(wBSAbound[k]<0)
		wBSAbound[k]=0
		endif
	EndFor
	
	return wBSAbound
End



//Function to Fit Association part of the spr signal
Function AssFit3(w,t) : FitFunc
	Wave w
	Variable t

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(t) = A0+Req1*(1-exp(-(kobs1*(t-t0))))+Req2*(1-exp(-(kobs2*(t-t0))))+Req3*(1-exp(-(kobs3*(t-t0))))
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ t
	//CurveFitDialog/ Coefficients 8
	//CurveFitDialog/ w[0] = Req1
	//CurveFitDialog/ w[1] = Req2
	//CurveFitDialog/ w[2] = Req3
	//CurveFitDialog/ w[3] = kobs1
	//CurveFitDialog/ w[4] = kobs2
	//CurveFitDialog/ w[5] = kobs3
	//CurveFitDialog/ w[6] = t0
	//CurveFitDialog/ w[7] = A0

	return w[7]+w[0]*(1-exp(-(w[3]*(t-w[6]))))+w[1]*(1-exp(-(w[4]*(t-w[6]))))+w[2]*(1-exp(-(w[5]*(t-w[6]))))
End

//Single Langmuir Isotherm Fit Function
Function LI(w,c) : FitFunc
	Wave w
	Variable c

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(c) = (Rmax*c)/(Kd+c)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ c
	//CurveFitDialog/ Coefficients 2
	//CurveFitDialog/ w[0] = Rmax
	//CurveFitDialog/ w[1] = Kd

	return (w[0]*c)/(w[1]+c)
End

//Two component Langmuir Isotherm Fit Function
Function LI2(w,c) : FitFunc
	Wave w
	Variable c

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(c) = (Rmax1*c/(Kd1+c))+(Rmax2*c/(Kd2+c))
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ c
	//CurveFitDialog/ Coefficients 4
	//CurveFitDialog/ w[0] = Rmax1
	//CurveFitDialog/ w[1] = Rmax2
	//CurveFitDialog/ w[2] = Kd1
	//CurveFitDialog/ w[3] = Kd2

	return (w[0]*c/(w[2]+c))+(w[1]*c/(w[3]+c))
End