#pragma rtGlobals=3		// Use modern global access method and strict wave access.


//ImportModel()
//Initialize()



Function Initialize(w)
	Wave w	//Data Wave 
	
	DFREF saveDFR = GetDataFolderDFR()
	
	SetDataFolder root:Model
	
	Variable/G numKineticVar
	Variable/G numObserVar
	Variable/G numLigBind=8000
	Variable/G numMwL=22000
	Variable/G numMwA=100000
	Variable/G A=125e-9
	Variable/G numOnStart=0
	Variable/G numOnEnd=595
	Variable/G numOffStart=595
	Variable/G numOffEnd=1070
	
	Variable i=0
	Wave kk
	If(!waveexists(kk) || numpnts(kk)!=(numKineticVar+1))
		make/O/N=(numKineticVar+1)	kk=NaN	//Kinetic constants wave pw[0], pw[1], ..., offset
	endif
	kk[numpnts(kk)-1]=w[0]
	String tmp=""
	For(;i<numpnts(kk);i +=1)
		sprintf tmp,"SetDimLabel 0,%d,k%d,kk",i,(i+1)
		Execute/Q tmp
	EndFor
	make/O/D/N=(numpnts(w),numObserVar) cw=NaN	//All observables
	make/O/D/N=(numpnts(w),numObserVar) cws=NaN	//All observables for simulation
	make/O/T/N=(numObserVar) wObsVar
	make/O/N=(numObserVar) wObsSelect=0
	wObsSelect[0]=1
	i=0
	For(;i<dimsize(cw,1);i +=1)
		wObsVar[i]="O"+num2str(i+1)
		sprintf tmp,"SetDimLabel 1,%d,O%d,cw,cws",i,(i+1)
		Execute/Q tmp
		cw[0][i] = 0
	EndFor
	
	Make/O/T/N=(numKineticVar) Constraints
	String/G gStrHold=""
	i=0
	For(;i<numKineticVar;i+=1)
		Constraints[i]="K"+num2str(i)+">0"
		gStrHold+="0"
	EndFor
	gStrHold+="1"
	

	DoWindow/K windowinit

	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1/N=windowinit/W=(319,69,1596,906)
	SetDrawLayer UserBack
	SetDrawEnv fsize= 24
	DrawText 29,63,"Kinetic Constants Init"
	SetDrawEnv fsize= 24
	DrawText 333,61,"Concentrations Init"
	SetDrawEnv fsize= 20
	DrawText 328,237,"Select Analyte"
	ListBox lb1,pos={329,249},size={91,195},proc=SetAnalyteInitConc,fSize=15
	ListBox lb1,listWave=wObsVar,selWave=wObsSelect,mode= 2,selRow=-1
	ListBox lb1,selRow= 0
	SetVariable sv1,pos={501,259},size={132,28},title="Start On",fSize=20
	SetVariable sv1,value=numOnStart
	SetVariable sv2,pos={501,303},size={137,28},title="End On",fSize=20
	SetVariable sv2,value=numOnEnd
	SetVariable sv3,pos={501,347},size={136,28},title="Start Off",fSize=20
	SetVariable sv3,value=numOffStart
	SetVariable sv4,pos={501,393},size={151,28},title="End Off",fSize=20
	SetVariable sv4,value=numOffEnd
	SetVariable sv5,pos={701,259},size={151,28},title="MW L",fSize=20
	SetVariable sv5,value=numMwL
	SetVariable sv6,pos={701,303},size={151,28},title="MW A",fSize=20
	SetVariable sv6,value=numMwA
	SetVariable sv7,pos={701,347},size={300,28},title="L Binding [RU]",fSize=20
	SetVariable sv7,value= numLigBind
	SetVariable sv8,pos={701,393},size={300,28},title="Injected Conc",fSize=20
	SetVariable sv8,value=A
	String/G str=nameofwave(w)
	SetVariable sv9,noedit=1,pos={901,259},size={151,28},value=str,fSize=20,title="Data"
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Model:
	Edit/W=(18,83,298,443)/HOST=#  kk.ld
	ModifyTable format(Point)=1,size(kk.ld)=14
	ModifyTable statsArea=85
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
	String fldrSav1= GetDataFolder(1)
	SetDataFolder root:Model:
	Edit/W=(326,84,1252,192)/HOST=#  cw.ld
	ModifyTable format(Point)=1,size(cw.d)=14
	ModifyTable statsArea=12
	SetDataFolder fldrSav1
	RenameWindow #,T1
	SetActiveSubwindow ##
	
	Button bn1,pos={284,528},size={239,67},disable=2,proc=GenFitFile,title="Generate Fit Procedure"
	Button bn2,pos={284,628},size={239,67},proc=fitit,title="Fit!"
	Button bn3,pos={284,728},size={239,67},proc=simit,title="simulate"
	
	SetDataFolder saveDFR

End

Function simit (ctrlName) : ButtonControl
	String ctrlName
	
	String/G str
	
	Wave cws,wSimOut
	Wave w=$str
	
	String cmd="Sim()"
	
	If(exists("Sim")==6)
		Execute/Q/Z cmd
		DoWindow/K SimOut
		Display/K=1/N=SimOut w
		AppendToGraph/W=SimOut wSimOut
		ModifyGraph rgb(wSimOut)=(0,0,65280)
		
	else
		print "User-defined function Sim() could not be found!"
	EndIf
	//Sim()
	
End

Function fitit (ctrlName) : ButtonControl
	String ctrlName
	
	Wave/T Constraints
	String/G str
	String/G gStrHold
	Wave w=$str
	Wave kk
	
	Display/K=1 w
	
	FuncFit/L=(numpnts(w))/N /H=gStrHold /M=2/NTHR=1 ChemFit kk  w /D/R/C=Constraints
	
End

Function SetAnalyteInitConc(ctrlName,row,col,event) : ListboxControl
	String ctrlName     // name of this control
	Variable row        // row if click in interior, -1 if click in title
	Variable col        // column number
	Variable event      // event code
	
	Wave cw,cws
	
	Variable/G numLigBind
	Variable/G numMwL
	
	ControlInfo lb1
	
	cw = NaN
	cws = NaN
	
	cw[0][] = 0
	cws[0][] = 0
	
	cw[0][V_Value] = (numLigBind*1e-9)/(1300*numMwL)	//Initial Ligand surface concentration in [mol/mm^2]
	cws[0][V_Value] = (numLigBind*1e-9)/(1300*numMwL)
	
	ModifyControl bn1 disable=0
	return 0            // other return values reserved
End


Function GenFitFile (ctrlName) : ButtonControl
	String ctrlName
	
	Variable/G numOnStart
	Variable/G numOnEnd
	Variable/G numOffStart
	Variable/G numOffEnd

	Variable f1
	
	ControlInfo lb1
	Variable selectedLigand=V_value


	String fileFilters="Igor Procedure File (*.ipf):.ipf;All Files:.*;"
	Open/F=fileFilters/M="Save Igor procedure containing your fitting routine" f1 as "KineticFit.ipf"
	 
	fprintf f1, "#pragma rtGlobals=3\r\r" // Insert modern global access method.

	GenerateChemFit1(f1,numOnStart,numOnEnd,numOffStart,numOffEnd,selectedLigand)

	Close f1		//close file 	

	
End


//Load Kinetic Model 

Function ImportModel()
	Variable f1, f2
	
	DFREF saveDFR = GetDataFolderDFR()
	
	NewDataFolder/O/S root:Model
	
	Open/R/M="Load text file containing your model." f1
	If(strlen(S_filename)!=0)
		print "Extracting model from text file: "+S_filename
		//extract data from input text file.
		parseModelFile(f1)
	else
		print "ImportModel(): Error loading model file (text file)."
	EndIf
	
	Close f1
	
	
	//create and open file igor text file procedure. Give default name KineticModel.ipf
	String fileFilters="Igor Procedure File (*.ipf):.ipf;All Files:.*;"
	Open/F=fileFilters/M="Save Igor procedure containing your kinetic model" f2 as "KineticModel.ipf"
	 
	fprintf f2, "#pragma rtGlobals=3\r\r" // Insert modern global access method.

	GenerateChemKinetic1(f2)
//	GenerateInitializeVars(f2)
//	GenerateUpdateLinearEqns(f2)
	Close f2		//close file 	
	
	SetDataFolder saveDFR
End

Function GenerateChemFit1(f1,startOn,endon,offstart,offend,selectedLigand)
	Variable f1
	Variable startOn,endon,offstart,offend,selectedLigand
	
	Variable/G numKineticVar
	Variable/G numObserVar
	
	Variable i
	
	fprintf f1, "//This File was generated by GenerateChemFit1()\r"
	fprintf f1, "Function ChemFit(pw,yw,xw) : FitFunc\r"
	fprintf f1, "\tWave pw,yw,xw\r\r"
	fprintf f1, "\tWave cw\r"
	fprintf f1, "\tVariable/G A\r\r"
	fprintf f1, "\tVariable/G C\r\r"
	fprintf f1, "\tVariable/G numMwA\r\r"
	fprintf f1, "\t//Integration of association part of the input data w\r"
	fprintf f1, "\tC=A\r"
	fprintf f1, "\tIntegrateODE/M=0/R=[%d,%d] ChemKinetic, pw, cw\r\r", startOn, endon
	fprintf f1, "\tC=0	//Set injected analyte concentration to zero\r"
		fprintf f1, "\tIntegrateODE/M=0/R=[%d,%d] ChemKinetic, pw, cw\r\r", offstart, offend	
		String tmp=""
		For(i=0;i<numObserVar;i+=1)
			If(i==selectedLigand)
				tmp+=""
			elseif(i==numObserVar-1)
				tmp+="cw[p]["+num2str(i)+"]"	
			else
				tmp+="cw[p]["+num2str(i)+"]+"	
			EndIf
		
		EndFor
	
	fprintf f1, "\tyw[]=pw[%d]+((%s)*numMwA*1e9*1300)\r\r",numKineticVar,tmp
	
	fprintf f1, "End\r\r"
	
	fprintf f1, "Function Sim()\r"
	fprintf f1, "\tWave cws\r"
	fprintf f1, "\tWave kk\r"
	fprintf f1, "\tVariable/G A\r\r"
	fprintf f1, "\tVariable/G C\r\r"
	fprintf f1, "\tVariable/G numMwA\r\r"
	fprintf f1, "\t//Integration of association part of the input data w\r"
	fprintf f1, "\tC=A\r"
	fprintf f1, "\tIntegrateODE/M=0/R=[%d,%d] ChemKinetic, kk, cws\r\r", startOn, endon
	fprintf f1, "\tC=0	//Set injected analyte concentration to zero\r"
	fprintf f1, "\tIntegrateODE/M=0/R=[%d,%d] ChemKinetic, kk, cws\r\r", offstart, offend
	tmp=""
		For(i=0;i<numObserVar;i+=1)
			If(i==selectedLigand)
				tmp+=""
			elseif(i==numObserVar-1)
				tmp+="cws[p]["+num2str(i)+"]"	
			else
				tmp+="cws[p]["+num2str(i)+"]+"	
			EndIf
		
		EndFor
	fprintf f1, "\tmake/O/N=(dimsize(cws,0)) wSimOut\r\r"
	fprintf f1, "\twSimOut[]=((%s))\r\r",tmp
	fprintf f1, "\twSimOut[]=wSimOut[p]*1e9*1300*numMwA+kk[%d]\r\r",numKineticVar
	fprintf f1, "End"
	
End

// This function will create the ChemKinetic function in the passed file refnum using previously 
// created variables and text waves.
Function GenerateChemKinetic1(f1)	//OK_DataFolderSafe
Variable f1//make refNum variable 
	
	Variable index = 0, numLoops 
	String tempVarName
	
	NVar numObserVar, numNonObserVar, numLinEqns, numKineticVar
	Wave/T parsedLinDef
	Wave/T parsedDiffDef
	

	//Create FunctionHeaders
	fprintf f1, "// This function was generated from an input text file.\r //It describes" 
	fprintf f1, " the kinetic model and calculates the derivatives\r"

	fprintf f1, "Function ChemKinetic(pw, tt, yw, dydt)\r"
	fprintf f1, "Wave pw\rVariable tt\rWave yw\rWave dydt\r\r"
	
	fprintf f1, "Variable/G C //concentration of injected analyte\r\r"

	//loop through variable declaration of local and globals
	numLoops = numNonObserVar
	// index = numNonObserVar - numLinEqns  //removed on 090209
//	for(; index < numLoops; index += 1)
//		tempVarName = "NO" + num2str(index+1)
//		if(index >= (numNonObserVar - numLinEqns) )
//			fprintf f1, "\tVariable %s\r", tempVarName
//		endif
//		tempVarName += "_init"
//		fprintf f1, "//NVAR %s = :gFolderVars:gNOVars:%s\r\r", tempVarName, tempVarName
//	endfor
	
	//cut and paste the parsed lines corresponding to the linear equations
	index = 0
	numLoops = numpnts(parsedLinDef)
	for(; index < numLoops; index += 1)
		fprintf f1, "\t%s\r", parsedLinDef[index]
	endfor

	fprintf f1, "\r"	
	
	//cut and paste the parsed lines corresponding to the differential equations
	index = 0
	numLoops = numpnts(parsedDiffDef)
	for(; index < numLoops; index += 1)
		fprintf f1, "\t%s\r", parsedDiffDef[index]
	endfor

	// Create a comments field as a conveniece to the user for keeping track of chemical species and
	// rate constants.
	fprintf f1, "\r\t// User may fill in the following fields as a convenience in keeping track of\r" 
	fprintf f1, "\t// different chemical species and rate constants. Save this file after adding fields.\r"
	
	fprintf f1, "\t// Chemical Species:\r"
	fprintf f1, "\t//\t Differential Equations:\r"
	for(index = 0; index < numLoops; index += 1)
		tempVarName = "yw[" + num2str(index) + "]"
		fprintf f1, "\t//\t %s = ", tempVarName
		if(index < numObserVar)
			tempVarName = "O" + num2str(index+1)
		else
			tempVarName = "NO" + num2str(index-numObserVar+1)
		endif
		fprintf f1, "%s = \r", tempVarName
	endfor		
	fprintf f1, "\t//\t Linear Equations:\r"
	numLoops = numNonObserVar
	index = numNonObserVar - numLinEqns
	for(; index < numLoops; index += 1)
		tempVarName = "NO" + num2str(index+1)
		fprintf f1, "\t//\t %s = \r", tempVarName
	endfor

	numLoops = numKineticVar
	fprintf f1, "\t//\r\t// Rate Constants:\r"
	for(index = 0; index < numLoops; index += 1)
		tempVarName = "pw[" + num2str(index) + "]"
		fprintf f1, "\t// %s = ", tempVarName
		tempVarName = "k" + num2str(index+1)
		fprintf f1, "%s = \r", tempVarName
	endfor
	
	fprintf f1,  "\rEnd\r"
End

Function parseModelFile(refNum)
	Variable refNum	//file reference
	
	Variable lineNumber, len
	Variable parserStepNumber = 0, numDiffEqns = 0
	String buffer
	String parsedLinEq = "", parsedDiffEq=""
	
	LineNumber = -1
	
	Do
		FReadLine refNum, buffer
		len = strlen(buffer)
		If(len == 0)
			break	//no more lines to be read
		EndIf
		
		//StripBracketingAndComments
		buffer = CleanBuffer(buffer)
		len = strlen(buffer)
		If(len)
			lineNumber += 1
			parserStepNumber = abs(parserStepNumber)
		else
			parserStepNumber = -1*abs(parserStepNumber)
		EndIf
		
		Switch(parserStepNumber)
		
			case 0:	//Initialize number of observables
				If(lineNumber == 0)
					Variable/G numObserVar = str2num(buffer)
					If(numObserVar == NaN)
						print "Execution crashed while reading this line: " + buffer
						Abort "Invalid Input encountered while processing input text file."
					EndIf
				elseif(lineNumber == 1)
					If(cmpstr(buffer,"***") == 0)
						parserStepNumber += 1
					Endif
				else
					print "Execution crashed while reading this line: " + buffer
					Abort "Invalid Input encountered while processing input text file."
				EndIf
				
				break
				
			case 1:	//Initialize number of non-observables
				if(lineNumber == 2)
					Variable/G numNonObserVar = str2num(buffer)
					if(numNonObserVar == NaN)
						print "Execution crashed while reading this line: " + buffer
						Abort "Invalid Input encountered while processing input text file."
					endif			
				elseif(lineNumber == 3)
					if(cmpStr(buffer,"***") == 0)
						parserStepNumber += 1
					else
						print "Execution crashed while reading this line: " + buffer
						Abort "Invalid Input encountered while processing input text file."
					endif
				else
					print "Execution crashed while reading this line: " + buffer
					Abort "Invalid Input encountered while processing input text file."
				endif
				
				break
							
			case 2:	// Initialize the variable for the number of kinetic parameters
				if(lineNumber == 4)
					variable/G numKineticVar = str2num(buffer)
					if(numKineticVar == NaN)
						print "Execution crashed while reading this line: " + buffer
						Abort "Invalid Input encountered while processing input text file."
					endif			
				elseif(lineNumber == 5)
					if(cmpStr(buffer,"***") == 0)
						parserStepNumber += 1
					else
						print "Execution crashed while reading this line: " + buffer
						Abort "Invalid Input encountered while processing input text file."
					endif
				else
					print "Execution crashed while reading this line: " + buffer
					Abort "Invalid Input encountered while processing input text file."
				endif
				
				break
			case 3: // Load the differential equations into a stringlist for later processing
				if(cmpStr(buffer,"***") == 0)
						parserStepNumber += 1
						if(linenumber == 6)
							print "Execution crashed while reading this line: " + buffer
							Abort "No Differential Equations encountered"
						endif
						
						break
				endif

				parsedDiffEq += buffer + ";" // the stringlist corresponding to all differential equation
				numDiffEqns += 1
				
				break
			case 4: // Load the Linear equations into a stringlist for later processing
				if(cmpStr(buffer,"***") == 0)
						parserStepNumber += 1
						Variable/G numLinEqns  //variable defined regardless of whether actual linear eqns present 
						numLinEqns = numObserVar + numNonObserVar - numDiffEqns			
						break
				endif

				parsedLinEq += buffer + ";" // the stringlist corresponding to all linear equation
				
				break
			case 5: // If the text file contains input lines after the last *** line then this case is reached
				print "Execution crashed while reading this line: " + buffer
				Abort "Unexpected input encountered following final \"***\" string."
		EndSwitch
	While(1)
	
	//Check for the proper number of parsed inputs
	if(parserStepNumber != 5)
		Print "Current Value of parserStepNumber Variable: ", parserStepNumber
		Abort "Incorrect number of \"***\" strings in text file. Check text file and try again."
	endif
	
	//Check that all variables have been initialized and that the inputs satisfy variable definitions
	if(exists("numObserVar") && exists("numNonObserVar") && exists("numKineticVar") && exists("numLinEqns"))
		if((numObserVar + numNonObserVar) != (numDiffEqns + numLinEqns))
			Print "numObserVar = ", numObserVar, " numNonObserVar = ", numNonObserVar,  " numDiffEqns = ", numDiffEqns, " numLinEqns = ", numLinEqns
			Abort "Variable numbers and equation count don't match."
		endif
	else
		Abort "The text file was interpreted incorrectly. Probably due to improperly defined text file."
	endif
	
	
translateDiffEqns2Igor1(parsedDiffEq)
translateLinEqns2Igor1(parsedLinEq)

End

// The following function replaces variables in the the more user-friendly text file format 
// with one that is appropriate in terms of an Igor function. 
// Built-in error checking looks for incomplete substitutions that could result if a variable definition typo
// is present in the input text file. Also, the lines containing equations corresponding to
// NO(K-M+1), ...., NON are properly ordered.
//
//	For simplicity we are using the following nomenclature in comments throughout:
//
//	M = number of observable variables
//	N = number of nonObservable variables
//	K = number of differential equations
//	L = number of linear equations

Function translateLinEqns2Igor1(linEqnsStringList) //OK_DataFolderSafe
string linEqnsStringList

	Variable numDiffEqns, numloops, index
	string linEqnsStringList_copy = linEqnsStringList
	string oldCurStr, newCurStr
	NVar numLinEqns, numNonObserVar, numObserVar

	Make/O/T/N=(numLinEqns) parsedLinDef
	
	numDiffEqns = numNonObserVar + numObserVar - numLinEqns	
	

	numLoops = (numDiffEqns <  numNonObserVar) ? numNonObserVar : numDiffEqns
	for(index = 0; index < numLoops; index +=1)
	
		// replace NO1_init ... NON_init with  lz1 ... lzN	
		// index < N
		if(index <  numNonObserVar)
			oldCurStr = "NO" + num2Str(index+1)+"_init"
			newCurStr = "lz" + num2Str(index +1)
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, "")
			// print "a index = ", index, " : " + linEqnsStringList  // Debug
		endif

		// replace NO1 ... NO(K-M) with  yw[M] ... yw[K-1]	
		// index < K-M
		if(index < (numDiffEqns - numObserVar))
			oldCurStr = "NO" + num2Str(index+1)
			newCurStr = "yw[" + num2Str(numObserVar + index) + "]"
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, "")
			// print "b index = ", index, " : " + linEqnsStringList  // Debug
		endif
		
		// replace NO(K-M+1) ... NON with  ly(K-M+1)...lyN  temporary placeholder 
		// to avoid false substitution in next step
		// Index >= K - M 
		if(index >= (numDiffEqns - numObserVar))
			oldCurStr = "NO" + num2Str(index + 1)
			newCurStr = "ly" + num2Str(index + 1)
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, newCurStr)				
			// print "c index = ", index, " : " + linEqnsStringList	// Debug
		endif	
		
		
		// replace O1 ... OM with yw[0] ... yw[M-1]
		// index < M
		if(index < numObserVar)
			oldCurStr = "O" + num2Str(index+1)
			newCurStr = "yw[" + num2Str(index) + "]"
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, "")
			// print "d index = ", index, " : " + linEqnsStringList	// Debug
		endif		
		
		// re-replace placeholder ly(K-M+1) ... lyN  back with NO(K-M+1) ... NON 
		// Index >= K - M 
		if(index >= (numDiffEqns - numObserVar))
			oldCurStr = "ly" + num2Str(index + 1)
			newCurStr = "NO" + num2Str(index + 1)
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)	
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, newCurStr)							
			// print "e index = ", index, " : " + linEqnsStringList	// Debug
		endif
		
		// re-replace placeholder lz1 ... lzN  back with NO1_init ... NON_init
		// Index < N
		if(index < numNonObserVar)
			oldCurStr = "lz" + num2Str(index + 1)
			newCurStr = "NO" + num2Str(index + 1) + "_init"
			linEqnsStringList = replaceString(oldCurStr,  linEqnsStringList, newCurStr)	
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, newCurStr)							
			// print "f index = ", index, " : " + linEqnsStringList		// Debug
		endif
	endfor
	
	// Perform substitution of remaining variables for error checking purposes
	for(index = 0; index < numNonObserVar; index +=1)
	
		// replace NO1_init ... NON_init and NO(K-M+1) ... NON  with null string
		// index < N
		oldCurStr = "NO" + num2Str(index+1) + "_init"
		linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, "")
		if(index >= (numDiffEqns - numObserVar))
			oldCurStr = "NO" + num2Str(index+1)
			linEqnsStringList_copy = replaceString(oldCurStr,  linEqnsStringList_copy, "")
		endif
	endfor	
	
	// print linEqnsStringList	// Debug
	// print linEqnsStringList_copy	// Debug

	// Check for mis-substituted variables
	if(checkForAlphaCharInStr1(linEqnsStringList_copy) != 0)
		Abort "Unknown expression found in differential equation"
	endif
	
	// Copy from string list to text wave
	for(index = 0; index < numLinEqns; index += 1)
		parsedLinDef[index] = StringFromList(index, linEqnsStringList)
	endfor

	// order the equations in case they are not ordered. Use this to check if the equations were all properly
	// defined and replaced.
	if(SortIndexedPrefixInWaves1("NO", parsedLinDef, (numDiffEqns - numObserVar+1)) < 1)
		Abort "Equations are not well ordered."
	endif
end


// The following function replaces variables in the the more user-friendly text file format 
// with the with one that is appropriate for use in an Igor function. 
// Built-in error checking looks for incomplete substitutions that might result if typos exist in variable definition 
// in the input text file. Also, the lines containing equations corresponding to
// dydt[0], ...., dydt[K-1] are properly ordered.
//
//	For simplicity we are using the following nomenclature in comments throughout:
//
//	M = number of observable variables
//	N = number of nonObservable variables
//	K = number of differential equations
//	L = number of linear equations
//	J = number of kinetic variables
Function translateDiffEqns2Igor1(diffEqnsStringList) //OK_DataFolderSafe
String diffEqnsStringList

	string oldCurStr, newCurStr
	string diffEqnsStringList_copy = diffEqnsStringList
	variable index = 0
	variable numLoops, numDiffEqns
	
	NVar numObserVar, numNonObserVar, numKineticVar, numLinEqns
	numDiffEqns = numObserVar + numNonObserVar - numLinEqns
	
	Make/O/T/N=(numDiffEqns) parsedDiffDef

	numLoops = (numObserVar < numKineticVar) ? numKineticVar : numObserVar
	numLoops = (numLoops < numNonObserVar) ? numNonObserVar : numLoops 
	
	for(; index < numLoops; index +=1)

		// replace dO1dt ... dOMdt with dydt[0] ... dydt[M-1]		
		// Index < M	
		if(index < numObserVar)
			oldCurStr = "dO" + num2Str(index + 1) + "dt"
			newCurStr = "dydt[" + num2Str(index) + "]"
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")
			// print "a index = ", index, " : " + diffEqnsStringList  // Debug
		endif

		// replace dNO1dt ... dNO(K-M)dt with dydt[M] ... dydt[K-1]
		//Index <  K-M
		if(index <  (numDiffEqns - numObserVar))
			oldCurStr = "dNO" + num2Str(index + 1) + "dt"
			newCurStr = "//dydt[" + num2Str(numObserVar + index) + "]"
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")
			// print "b index = ", index, " : " + diffEqnsStringList  // Debug		
		endif

		// replace NO1 ... NO(K-M) with  yw[M] ... yw[K-1]
		// Index <  K - M 
		if(index < (numDiffEqns - numObserVar))
			oldCurStr = "NO" + num2Str(index + 1)
			newCurStr = "C"
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)	
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")		
			// print "c index = ", index, " : " + diffEqnsStringList  // Debug		
		endif
		
		// replace NO(K-M+1) ... NON with  lz(K-M+1)...lzN  temporary placeholder 
		// to avoid false substitution in next-step
		// Index >= K - M 
		if(index >= (numDiffEqns - numObserVar))
			oldCurStr = "NO" + num2Str(index + 1)
			newCurStr = "lz" + num2Str(index + 1)
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)	
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")		
			// print "d index = ", index, " : " + diffEqnsStringList  // Debug		
		endif		
	
		// replace O1 ... OM with yw[0] ... yw[M-1]
		// Index < M
		if(index < numObserVar)
			oldCurStr = "O" + num2Str(index + 1)
			newCurStr = "yw[" + num2Str(index) + "]"
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)	
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")		
			// print "e index = ", index, " : " + diffEqnsStringList  // Debug		
		endif

		// re-replace placeholder lz(K-M+1) ... lzN  back with NO(K-M+1) ... NON 
		// Index >= K - M 
		if(index >= (numDiffEqns - numObserVar))
			oldCurStr = "lz" + num2Str(index + 1)
			newCurStr = "NO" + num2Str(index + 1)
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)	
			// print "f index = ", index, " : " + diffEqnsStringList  // Debug		
		endif
		
		// replace k1 ... kJ with pw[0] ... pw[J-1]
		// Index < J
		if(index <  numKineticVar)
			oldCurStr = "k" + num2Str(index + 1)
			newCurStr = "pw[" + num2Str(index) + "]"
			diffEqnsStringList = replaceString(oldCurStr,  diffEqnsStringList, newCurStr)	
			diffEqnsStringList_copy = replaceString(oldCurStr,  diffEqnsStringList_copy, "")		
			// print "g index = ", index, " : " + diffEqnsStringList  // Debug		
		endif
	endfor	
	
	// print diffEqnsStringList  //Debug
	// print diffEqnsStringList_copy //Debeg

	// Check for mis-substituted variables
	if(checkForAlphaCharInStr1(diffEqnsStringList_copy) != 0)
		Abort "Unknown expression found in differential equation"
	endif
	
	// Copy from string list to text wave
	numLoops = numDiffEqns
	for(index = 0; index < numLoops; index += 1)
		parsedDiffDef[index] = StringFromList(index, diffEqnsStringList)
	endfor

	// order the equations in case they are not ordered. Use this also to check if the equations were all properly
	// defined and replaced.
	if(SortIndexedPrefixInWaves1("dydt[", parsedDiffDef, 0) < 1)
		Abort "Equations are not well ordered."
	endif
end 

// This function removes whiteSpace (i.e " " or "\t" chars) from the beginning and the end of the
// passed string. It also removes comments embedded in a string.
Function/S CleanBuffer(str)
	String str
	
	Variable n = strlen(str)
	Variable start = 0
	Variable ende = n-1
	Variable v
	
	If( n > 0)
		
		String char
		// remove tabs and spaces from the front of the string.
		Do
			char=str[start,start]
			v=strsearch(" \t",char,0)
			If(v == -1)	//char is not space or tab
				break
			EndIf	
			start += 1
		While( start < n )
		
		//remove comments where they occur
		v = strsearch(str,"//", start)
		If( v != -1 )
			ende = v - 1
		EndIf
		
		If( start <= ende ) 		// after skipping leading white space, there are chars left
				
			// remove white space from the end of the string.
			Do
				char= str[ende,ende]
				v= strsearch(" \t\r\n",char,0)
				If(v == -1 )	// char is not space, tab, CR, or LF
					break
				EndIf
				ende -= 1
			While( ende > start )
		EndIf
	EndIf
	
	return str[start,ende]
End

// Sort the text wave sortedWaveName by occurance of indexed prefix (i.e prefix1, prefix2, ..., prefixN)
// in the text Wave. This is useful for sorting equations by their indexed variables. Note the prefix is case-
// sensitive. SortIndexedPrefixInWaves() return a value of 1 if the sort is successful, otherwise a value of
// the following error code is returned with wave unsorted
//
// Error Value: -1		This occures if one of the indexed Prefixes was not found in the text Wave
// Error Value: -2		This occures is a particular value of the indexed Prefix occured in multiple
//						rows of the sortedWaveName. In other words, the indexed Prefix is not unique.							
Function SortIndexedPrefixInWaves1(prefix, sortedWaveName, startIndex) //OK_DataFolderSafe
String prefix
Wave/T sortedWaveName
Variable startIndex


	variable index = 0, itor, returnVal
	variable numLoops = numpnts(sortedWaveName)
	If(numLoops == 0)	//there is nothing to sort...
		return 1
	EndIf
	string indexedPrefix 
	make/D/O/N=(numLoops) sortKeyWaves
	sortKeyWaves = -1 // set all values to false
	do
		indexedPrefix = prefix + num2str(index + startIndex)
		for(itor = 0; itor < numLoops; itor +=1)
			returnVal = strSearch(sortedWaveName[itor], indexedPrefix, 0)
			if(returnVal >= 0)
				if(sortKeyWaves[index] >= 0)
					return -2 // multiple instances of indexed variable
				else
					sortKeyWaves[index] = itor
				endif
			endif
		endfor
		
		if(sortKeyWaves[index] == -1)
			return -1 // indexed prefix not found
		endif
		
		//print indexedPrefix + ": " + sortKeyWaves
		index += 1
	while(index < numLoops)

	IndexSort sortKeyWaves, sortedWaveName 
	KillWaves/Z sortKeyWaves
	return 1 // successfull sort operation
End

// If a string contains an upper- or lower- case alphabetic character, that character is returned
// Otherwise 0 is returned if no characters are encountered.
function checkForAlphaCharInStr1(strExpression) //OK_DataFolderSafe
String strExpression

	Variable length = strlen(strExpression), index = 0
	Variable ASCIIVal
	for(; index < length -1; index +=1)
		ASCIIVal = char2num(strExpression[index, index])
		
		if((ASCIIVal <= 90  && ASCIIVal >= 65) || (ASCIIVal >= 97  && ASCIIVal <= 122))
			return ASCIIVal
		endif
	endfor
	
	return 0
end

// simple function that performs a basic check to see that a valid simple foldername has been
// passed to it and if the string exceed a certain length. The tests are 1) is the first character 
// a number 2) are there any spaces 3) the string length exceeds 20. Returns 0 if an
// invalid forder name is passed, otherwise returns 1
function checkForSimpleName1(strExpression) //OK_DataFolderSafe
String strExpression

	Variable length = strlen(strExpression), index = 0
	Variable ASCIIVal
	
	if(length > 20)
		return 0
	endif
	
	ASCIIVal = char2num(strExpression[0,0])
	
	if(ASCIIVal <= Char2Num("9")  && ASCIIVal >= Char2Num("0"))
		return 0
	endif
	
	for(; index < length -1; index +=1)
		ASCIIVal = char2num(strExpression[index, index])
		
		if(ASCIIVal ==  char2num(" "))
			return 0
		endif
	endfor
	return 1
end