#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function SimpleOnFit()

	ChooseActiveDF(1)	//Choose Experiment
	ChooseActiveFCDF(1)	//Choose Flow Cell

	NewDataFolder/O Fits
	
	//List all waves in folder
	Wave/T wRef	//Contains all relevant wave names
	Variable i
	Wave wt=$("::Times")
	Wave c=$("::Concs")
	Make/T/N=(numpnts(c)) ConcsT
	ConcsT[]=num2str(c[p])
	
	//Display all waves in folder
	DoWindow/K res
	Display/K=1/N=res $wRef[0]
	String wName="res"
	For(i=1;i<numpnts(wRef);i+=1)	//wRef[0] already displayed before
		AppendToGraph/W=$wName $wRef[i]
	EndFor
	Legend/W=$wName/C/N=text0/A=RT
	ShowInfo/CP=0/W=$wName
	SetAxis bottom,0,rightx($wRef[1])*2
	Cursor/A=1 A $wRef[numpnts(wRef)-1] wt[0][1]-wt[0][0]-4
	
	
	//Panel to choose fitting parameters and start fit
	Make/O/N=(numpnts(wRef)) swave=1,swave2=0
	DoWindow/K sfit
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1/N=sfit /W=(650,64,1600,674)
	SetDrawLayer UserBack
	SetDrawEnv fsize=20
	DrawText 46,31,"Choose End Point of Fit First!!"
	SetDrawEnv fsize=20
	DrawText 384,47,"Choose Curves to Fit"
	SetDrawEnv fsize=15
	DrawText 600,47,"Take Marker Value for Req"
	SetDrawEnv fsize=15
	DrawText 816,47,"Concs"
	Button bn1,pos={284,528},size={239,67},proc=startfit,title="Start Fitting!"
	Button bn1,font="Arial Greek",fSize=20,fColor=(0,39168,19712)
	Button bn2,pos={153,207},size={150,60},proc=checkfit,title="Check Parameters"
	Button bn2,font="Arial Greek",fSize=15,fColor=(0,39168,19712)
	SetVariable sv1,pos={50,50},size={150,20},title="kobs1",font="Arial Greek"
	SetVariable sv1,fSize=15,value= _NUM:0.57
	SetVariable sv2,pos={50,100},size={150,20},title="kobs2",font="Arial Greek"
	SetVariable sv2,fSize=15,value= _NUM:0.0475	
	SetVariable sv3,pos={50,150},size={150,20},title="kobs3",font="Arial Greek"
	SetVariable sv3,fSize=15,value= _NUM:0.00465
	SetVariable sv4,pos={220,50},size={150,20},title="Req1",font="Arial Greek"
	SetVariable sv4,fSize=15,value= _NUM:207
	SetVariable sv5,pos={220,100},size={150,20},title="Req2",font="Arial Greek"
	SetVariable sv5,fSize=15,value= _NUM:330
	SetVariable sv6,pos={220,150},size={150,20},title="Req3",font="Arial Greek"
	SetVariable sv6,fSize=15,value= _NUM:813
	ListBox lb1,pos={384,56},size={150,300},fSize=15,mode=4,listWave=wRef,SelWave=swave,proc=selector
	ListBox lb2,pos={600,56},size={150,300},fSize=15,mode=4,listWave=wRef,SelWave=swave2
	ListBox lb3,pos={816,56},size={100,300},fSize=15,mode=0,listWave=ConcsT
End

Function startfit (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	SetDataFolder sref
		
	Variable Pendfit=pcsr(A)
	String wName=csrwave(A)
	Wave w=$wName
	Wave swave	//containts wave ref for waves selected for fit

	Variable i

	ControlInfo/W=sfit sv1
	Variable kobs1=V_value
	ControlInfo/W=sfit sv2
	Variable kobs2=V_value
	ControlInfo/W=sfit sv3
	Variable kobs3=V_value
	ControlInfo/W=sfit sv4
	Variable Req1=V_value
	ControlInfo/W=sfit sv5
	Variable Req2=V_value
	ControlInfo/W=sfit sv6
	Variable Req3=V_value
	Variable A0=w[0]
	
	//Make Initial guesses wave
	Make/O/D/N=8 W_coef
	W_coef[0]=Req1
	W_coef[1]=Req2
	W_coef[2]=Req3
	W_coef[3]=kobs1
	W_coef[4]=kobs2
	W_coef[5]=kobs3
	W_coef[6]=0
	W_coef[7]=A0
	
	
	Wave/T wRef	//contains all fit relevant wave names
	Make/T/O/N=0 waves2fit
	For(i=0;i<numpnts(wRef);i+=1)
		If(swave[i])
			Redimension/N=(numpnts(waves2fit)+1) waves2fit
			waves2fit[numpnts(waves2fit)-1]=wRef[i]
		EndIf
	EndFor
	
	//Start Fitting
	Make/O/D/N=(numpnts(waves2fit),8) :Fits:fitRes=NaN
	Make/O/D/N=(numpnts(swave)) :Fits:Reqtot=NaN
	Wave res=$(":Fits:fitRes")	//Fit Results wave
	Wave reqtot=$(":Fits:Reqtot")	//Total equilibrium response from fit
	Wave c=$("::Concs")
	If(!waveexists(c))
		print "Enter Concentrations of Injections in [M] or load sample concentration list from Menu!"
		Make/D/N=(numpnts(wRef)) ::Concs
		Edit/K=1 ::Concs
		return -1
	EndIf
	Make/O/D/N=0 concs
	For(i=0;i<numpnts(swave);i+=1)
		If(swave[i])
			Redimension/N=(numpnts(concs)+1) concs
			concs[numpnts(concs)-1]=c[i]
		EndIf
	EndFor

//	NewPanel /N=ProgressPanel /W=(285,111,739,193)
//	ValDisplay valdisp0,pos={18,32},size={342,18},limits={0,(numpnts(w)),0},barmisc={0,0}
//	ValDisplay valdisp0,value= _NUM:0
//	ValDisplay valdisp0,mode= 3
//	ValDisplay valdisp0,highColor=(0,65535,0)
//	Button bStop,pos={375,32},size={50,20},title="Stop"
//	DoUpdate /W=ProgressPanel /E=1	// mark this as our progress window
	Variable pos=0
	For(i=0;i<numpnts(waves2fit);i+=1)
	
		//Data Wave to fit to
		Wave wf=$(waves2fit[numpnts(waves2fit)-1-i])
		W_coef[7]=wf[0]
		
		//Make constraints wave for fitting
		Make/O/T wConstraints={"K0 >= 0","K1 >= 0", "K2 >= 0","K3 >= 0","K4 >= 0", "K5 >= 0"}
	
		//Fit Data Range using given Fit Function
		FuncFit/W=2/N/Q/L=(numpnts(w))/X/H="00000011"/NTHR=1 AssFit3 W_coef wf[0,Pendfit] /D/R/A=0/C=wConstraints
		///TBOX=857
		
		ModifyGraph rgb($("fit_"+nameofwave(wf)))=(0,0,65280)	//display fit in blue
	
		//Write Fit Results into fitRES wave in Fit Folder
		res[i][0]=W_coef[0]	//Req1
		res[i][1]=W_coef[1]	//Req2
		res[i][2]=W_coef[2]	//Req3
		res[i][3]=W_coef[3]	//kobs1
		res[i][4]=W_coef[4]	//kobs2
		res[i][5]=W_coef[5]	//kobs3
		res[i][6]=W_coef[6]	//t0
		res[i][7]=W_coef[7]	//A0
		
//		ValDisplay valdisp0,value= _NUM:i+1,win=ProgressPanel
//		DoUpdate /W=ProgressPanel

		//Calculate Total equilibrum response from fit results
		Variable j=0
		Do
			j+=1
		While(!swave[(numpnts(swave))-j] && j<(numpnts(swave)-1))	
		swave[(numpnts(swave))-j]=0		
		reqtot[(numpnts(reqtot))-j]=res[i][0]+res[i][1]+res[i][2]+res[i][7]
		
	EndFor
//	KillWindow ProgressPanel
//	DoWindow/K sfit	//Kill control window

	//Fill total equilibrium wave with selected "only take value from curve" waves
	Wave swave2
	For(i=0;i<numpnts(swave2);i+=1)
		if(swave2[i])
			Wave g=$wRef[i]
			reqtot[i]=g[Pendfit]
		endif
	EndFor
	
	
	//correct concs and reqtot points for affinity fitting
	Make/O/D/N=0 concs
	Make/FREE/D/N=0 temp
	For(i=0;i<numpnts(reqtot);i+=1)
		If(reqtot[i])
			Redimension/N=(numpnts(concs)+1) concs
			Redimension/N=(numpnts(temp)+1) temp
			concs[numpnts(concs)-1]=c[i]
			temp[numpnts(temp)-1]=reqtot[i]
		Endif
	EndFor
	
	Duplicate/O temp reqtot
//	reverse reqtot	//reverse wave for displaying against concentration wave in increasing order
	
		
	If(numpnts(reqtot) < 5)
		print "DataSet for total equilibrium too small to fit!"
		return -1
	EndIf
	
	////Single Component Langmuir Isotherm Fit///////
	Display/K=1 reqtot vs concs	//Displays equilibrium response against injected concetration of analyte
	ModifyGraph mode=3,marker=24,msize=5,mrkThick=1.5,rgb=(0,52224,26368)
	Wavestats/Q reqtot
	SetAxis left 0,(V_max*1.5)
	SetAxis bottom 0,((concs[numpnts(concs)-1])*3)
	Legend/C/N=text0 /TR
	
	//Make W_coef for Langmuir isotherm fit
	Make/O/D/N=2 W_coef
	W_coef[0]=reqtot[numpnts(reqtot)-1]*1.5	//Rmax
	W_coef[1]=1e-6	//Kd
	
	//Fit Langmuir Isotherm
	FuncFit/N/Q/TBOX=857/L=(numpnts(concs)*200)/X/NTHR=1 LI W_coef reqtot /X=concs /D/R/A=0
	Duplicate/O $("fit_"+nameofwave(reqtot)) $("fit_"+nameofwave(reqtot)+"LI")
	RemoveFromGraph $("fit_"+nameofwave(reqtot))
	AppendToGraph $("fit_"+nameofwave(reqtot)+"LI")
	
	////Single Component Langmuir Isotherm Fit End///////
	
	////Double Component Langmuir Isotherm Fit///////
	Display/K=1 reqtot vs concs	//Displays equilibrium response against injected concetration of analyte
	ModifyGraph mode=3,marker=24,msize=5,mrkThick=1.5,rgb=(0,52224,26368)
	Wavestats/Q reqtot
	SetAxis left 0,(V_max*1.5)
	SetAxis bottom 0,((concs[numpnts(concs)-1])*3)
	Legend/C/N=text0 /TR
	
	//Make W_coef for Two component Langmuir isotherm fit
	Make/O/D/N=4 W_coef
	W_coef[0]=reqtot[numpnts(reqtot)-1]*0.7	//Rmax1
	W_coef[1]=reqtot[numpnts(reqtot)-1]*0.7	//Rmax2
	W_coef[2]=50e-9	//Kd1
	W_coef[3]=1e-6	//Kd2
	
	//Fit Two component Langmuir Isotherm
	FuncFit/N/Q/TBOX=857/L=(numpnts(concs)*200)/X/NTHR=1 LI2 W_coef reqtot /X=concs /D/R/A=0
	Duplicate/O $("fit_"+nameofwave(reqtot)) $("fit_"+nameofwave(reqtot)+"LI2")
	RemoveFromGraph $("fit_"+nameofwave(reqtot))
	AppendToGraph $("fit_"+nameofwave(reqtot)+"LI2")
//	Wavestats/Q reqtot
//	SetAxis left 0,(V_max*1.5)
//	SetAxis bottom 0,((concs[numpnts(concs)-1])*2)
//	Legend/C/N=text0 /TR
	////Double Component Langmuir Isotherm Fit End///////
End

Function checkfit (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	SetDataFolder sref
		
	Variable Pendfit=pcsr(A)
	String wName=csrwave(A)
	Wave w=$wName
	
	
	//Take initial guesses and simulate curve
	String wsim=":Fits:"+nameofwave(w)+"sim"
	make/O/D/N=(numpnts(w)) $wsim
	Wave ws=$wsim
	setscale/I x,leftx(w),rightx(w),"s",ws
	
	ControlInfo/W=sfit sv1
	Variable kobs1=V_value
	ControlInfo/W=sfit sv2
	Variable kobs2=V_value
	ControlInfo/W=sfit sv3
	Variable kobs3=V_value
	ControlInfo/W=sfit sv4
	Variable Req1=V_value
	ControlInfo/W=sfit sv5
	Variable Req2=V_value
	ControlInfo/W=sfit sv6
	Variable Req3=V_value
	Variable A0=w[0]
	
		
	ws[]=A0+Req1*(1-exp(-(kobs1*(p/(dcRate*10)))))+Req2*(1-exp(-(kobs2*(p/(dcRate*10)))))+Req3*(1-exp(-(kobs3*(p/(dcRate*10)))))
	
	Removefromgraph/Z/W=res $nameofwave(ws)
	AppendToGraph/W=res ws
	ModifyGraph rgb($nameofwave(ws))=(0,0,65280)
			
	//Make Initial guesses wave
	Make/O/D/N=8 W_coef
	W_coef[0]=Req1
	W_coef[1]=Req2
	W_coef[2]=Req3
	W_coef[3]=kobs1
	W_coef[4]=kobs2
	W_coef[5]=kobs3
	W_coef[6]=0
	W_coef[7]=A0

	
End

Function selector(ctrlName,row,col,event) : ListboxControl
	String ctrlName     // name of this control
	Variable row        // row if click in interior, -1 if click in title
	Variable col        // column number
	Variable event      // event code
	
	wave swave,swave2
	
	Variable i
//	For(i=0;i<numpnts(swave);i+=1)
		swave2[]=!swave[p]
//	EndFor
	
	return 0            // other return values reserved
End


//Function to Fit Association part of the spr signal
Function AssFit3(w,t) : FitFunc
	Wave w
	Variable t

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(t) = A0+Req1*(1-exp(-(kobs1*(t-t0))))+Req2*(1-exp(-(kobs2*(t-t0))))+Req3*(1-exp(-(kobs3*(t-t0))))
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ t
	//CurveFitDialog/ Coefficients 8
	//CurveFitDialog/ w[0] = Req1
	//CurveFitDialog/ w[1] = Req2
	//CurveFitDialog/ w[2] = Req3
	//CurveFitDialog/ w[3] = kobs1
	//CurveFitDialog/ w[4] = kobs2
	//CurveFitDialog/ w[5] = kobs3
	//CurveFitDialog/ w[6] = t0
	//CurveFitDialog/ w[7] = A0

	return w[7]+w[0]*(1-exp(-(w[3]*(t-w[6]))))+w[1]*(1-exp(-(w[4]*(t-w[6]))))+w[2]*(1-exp(-(w[5]*(t-w[6]))))
End

//Single Langmuir Isotherm Fit Function
Function LI(w,c) : FitFunc
	Wave w
	Variable c

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(c) = (Rmax*c)/(Kd+c)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ c
	//CurveFitDialog/ Coefficients 2
	//CurveFitDialog/ w[0] = Rmax
	//CurveFitDialog/ w[1] = Kd

	return (w[0]*c)/(w[1]+c)
End

//Two component Langmuir Isotherm Fit Function
Function LI2(w,c) : FitFunc
	Wave w
	Variable c

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(c) = (Rmax1*c/(Kd1+c))+(Rmax2*c/(Kd2+c))
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ c
	//CurveFitDialog/ Coefficients 4
	//CurveFitDialog/ w[0] = Rmax1
	//CurveFitDialog/ w[1] = Rmax2
	//CurveFitDialog/ w[2] = Kd1
	//CurveFitDialog/ w[3] = Kd2

	return (w[0]*c/(w[2]+c))+(w[1]*c/(w[3]+c))
End