#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function ManualOffFit()

ChooseActiveDF(1)	//Choose Experiment
	Variable/G gOffRef=ChooseActiveFCDF(1)	//Choose Flow Cell

	NewDataFolder/O Fits
	
	//List all waves in folder
	Wave/T wRef	//Contains all relevant wave names
	Variable i
	Wave wt=$("::Times")
	Wave c=$("::Concs")
	Wave/T ConcsT
	If(!waveexists(ConcsT))
		Make/T/N=(numpnts(c)) ConcsT
		ConcsT[]=num2str(c[p])
	EndIf
	//Display all waves in folder
	DoWindow/K res
	Display/W=(5,10,700,500)/K=1/N=res $wRef[0]
	String wName="res"
	For(i=1;i<numpnts(wRef);i+=1)	//wRef[0] already displayed before
		AppendToGraph/W=$wName $wRef[i]
	EndFor
	ShowInfo/CP=0/W=$wName
	SetAxis bottom,wt[0][6]-wt[0][3]-5,wt[0][6]-wt[0][3]+40
	Cursor/A=1 A $wRef[numpnts(wRef)-1] wt[0][1]-wt[0][0]-4
	
	DoWindow/K mFit
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1 /N=mFit /W=(1037,64,1374,338)
	Button bn1,pos={115,213},size={166,47},proc=manfit,title="Throw Bomb!",fSize=20
	Button bn1,fColor=(52224,0,0)
	Button bn2,pos={13,232},size={66,24},proc=showResults,title="Edit Result"
	SetVariable sv1,pos={93,162},size={197,20},title="Seconds to fit",fSize=14
	SetVariable sv1,limits={-inf,inf,0},value= _NUM:400
	SetVariable sv2,pos={4,5},size={150,20},title="R1",font="Arial Greek",fSize=15
	SetVariable sv2,value= _NUM:200
	SetVariable sv3,pos={4,55},size={150,20},title="R2",font="Arial Greek",fSize=15
	SetVariable sv3,value= _NUM:200
	SetVariable sv4,pos={174,5},size={150,20},title="koff1",font="Arial Greek"
	SetVariable sv4,fSize=15,value= _NUM:0.6
	SetVariable sv5,pos={174,55},size={150,20},title="koff2",font="Arial Greek"
	SetVariable sv5,fSize=15,value= _NUM:0.01
	SetVariable sv6,pos={174,105},size={150,20},title="koff3",font="Arial Greek"
	SetVariable sv6,fSize=15,value= _NUM:0.0001
	

End


Function SimpleOffFit()

	ChooseActiveDF(1)	//Choose Experiment
	Variable/G gOffRef=ChooseActiveFCDF(1)	//Choose Flow Cell

	NewDataFolder/O Fits
	
	//List all waves in folder
	Wave/T wRef	//Contains all relevant wave names
	Variable i
	Wave wt=$("::Times")
	Wave c=$("::Concs")
	Wave/T ConcsT
	If(!waveexists(ConcsT))
		Make/T/N=(numpnts(c)) ConcsT
		ConcsT[]=num2str(c[p])
	EndIf
	//Display all waves in folder
	DoWindow/K res
	Display/K=1/N=res $wRef[0]
	String wName="res"
	For(i=1;i<numpnts(wRef);i+=1)	//wRef[0] already displayed before
		AppendToGraph/W=$wName $wRef[i]
	EndFor
	Legend/W=$wName/C/N=text0/A=RT
	ShowInfo/CP=0/W=$wName
	SetAxis bottom,wt[0][6]-wt[0][3],rightx($wRef[1])*2
	Cursor/A=1 A $wRef[numpnts(wRef)-1] wt[0][1]-wt[0][0]-4
	
	
	//Panel to choose fitting parameters and start fit
	Make/D/O/N=(numpnts(wRef)) swave=1,swave2=0
	DoWindow/K sfit2
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1/N=sfit2 /W=(650,64,1600,674)
	SetDrawLayer UserBack
	SetDrawEnv fsize=20
//	DrawText 46,31,"Choose End Point of Fit First!!"
//	SetDrawEnv fsize=20
	DrawText 384,47,"Choose Curves to Fit"
	SetDrawEnv fsize=15
//	DrawText 600,47,"Take Marker Value for Req"
	SetDrawEnv fsize=15
	DrawText 600,47,"Concs"
	Button bn1,pos={284,528},size={239,67},proc=startfit2,title="Start Fitting!"
	Button bn1,font="Arial Greek",fSize=20,fColor=(0,39168,19712)
	Button bn2,pos={153,207},size={150,60},proc=checkfit2,title="Check Parameters"
	Button bn2,font="Arial Greek",fSize=15,fColor=(0,39168,19712)
//	SetVariable sv1,pos={50,50},size={150,20},title="R0",font="Arial Greek"
//	SetVariable sv1,fSize=15,value= _NUM:0.57
	SetVariable sv2,pos={50,50},size={150,20},title="R1",font="Arial Greek"
	SetVariable sv2,fSize=15,value= _NUM:100
	SetVariable sv3,pos={50,100},size={150,20},title="R2",font="Arial Greek"
	SetVariable sv3,fSize=15,value= _NUM:160
	SetVariable sv4,pos={220,50},size={150,20},title="koff1",font="Arial Greek"
	SetVariable sv4,fSize=15,value= _NUM:0.25
	SetVariable sv5,pos={220,100},size={150,20},title="koff2",font="Arial Greek"
	SetVariable sv5,fSize=15,value= _NUM:0.01
	SetVariable sv6,pos={220,150},size={150,20},title="koff3",font="Arial Greek"
	SetVariable sv6,fSize=15,value= _NUM:5e-5
	ListBox lb1,pos={384,56},size={150,300},fSize=15,mode=4,listWave=wRef,SelWave=swave
	ListBox lb3,pos={600,56},size={100,300},fSize=15,mode=0,listWave=ConcsT

End

Function checkfit2 (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	Variable/G gOffRef
	SetDataFolder sref
	
	Wave wt=$("::Times")
	
	Variable Pstartfit
	Variable Pendfit

	String wName=csrwave(A)
	Wave w=$wName
	
	
	//Take initial guesses and simulate curve
	String wsim=":Fits:"+nameofwave(w)+"simOff"
	make/O/D/N=(numpnts(w)) $wsim
	Wave ws=$wsim
	setscale/I x,leftx(w),rightx(w),"s",ws
	
	Variable t0=wt[0][5+gOffRef]-wt[0][2+gOffRef]
	ControlInfo/W=sfit2 sv1
	Variable R0=w[t0*dcRate*10]
	ControlInfo/W=sfit2 sv2
	Variable R1=V_value
	ControlInfo/W=sfit2 sv3
	Variable R2=V_value
	ControlInfo/W=sfit2 sv4
	Variable koff1=V_value
	ControlInfo/W=sfit2 sv5
	Variable koff2=V_value
	ControlInfo/W=sfit2 sv6
	Variable koff3=V_value
	

	ws[]= (R0-R1-R2)*exp(-koff3*((p/(dcRate*10))-t0))+(R1)*exp(-koff1*((p/(dcRate*10))-t0))+(R2)*exp(-koff2*((p/(dcRate*10))-t0))
	
	GetAxis/W=res left
	Removefromgraph/Z/W=res $nameofwave(ws)
	AppendToGraph/W=res ws
	ModifyGraph rgb($nameofwave(ws))=(0,0,65280)
	SetAxis/W=res left,V_min,V_maX
			
	//Make Initial guesses wave
	Make/O/D/N=7 W_coef
	W_coef[0]=R0
	W_coef[1]=R1
	W_coef[2]=R2
	W_coef[3]=koff1
	W_coef[4]=koff2
	W_coef[5]=koff3
	W_coef[6]=t0


	
End

Function startfit2 (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	Variable/G gOffRef
	SetDataFolder sref
	
	Wave wt=$("::Times")
	
	Variable Pstartfit=(wt[0][5+gOffRef]-wt[0][2+gOffRef])*dcRate*10
	Variable Pendfit=(wt[0][2]-wt[0][2+gOffRef])*dcRate*10

	String wName=csrwave(A)
	Wave w=$wName
		

	Wave swave	//containts wave ref for waves selected for fit

	Variable i

	Variable t0=wt[0][5+gOffRef]-wt[0][2+gOffRef]
	ControlInfo/W=sfit2 sv1
	Variable R0=w[t0*dcRate*10]
	ControlInfo/W=sfit2 sv2
	Variable R1=V_value
	ControlInfo/W=sfit2 sv3
	Variable R2=V_value
	ControlInfo/W=sfit2 sv4
	Variable koff1=V_value
	ControlInfo/W=sfit2 sv5
	Variable koff2=V_value
	ControlInfo/W=sfit2 sv6
	Variable koff3=V_value
	
	//Make Initial guesses wave
	Make/O/D/N=7 W_coef
	W_coef[0]=R0
	W_coef[1]=R1
	W_coef[2]=R2
	W_coef[3]=koff1
	W_coef[4]=koff2
	W_coef[5]=koff3
	W_coef[6]=t0
	
	
	Wave/T wRef	//contains all fit relevant wave names
	Make/T/O/N=0 waves2fit
	Make/D/O/N=0 wPstart
	For(i=0;i<numpnts(wRef);i+=1)
		If(swave[i])
			Redimension/N=(numpnts(waves2fit)+1) waves2fit
			Redimension/N=(numpnts(wPstart)+1) wPstart
			waves2fit[numpnts(waves2fit)-1]=wRef[i]
			wPstart[numpnts(wPstart)-1]=(wt[i][5+gOffRef]-wt[i][2+gOffRef])*dcRate*10
		EndIf
	EndFor
	
	//Start Fitting
	Make/O/D/N=(numpnts(waves2fit),8) :Fits:fitResOff=NaN
	Wave res=$(":Fits:fitResOff")	//Fit Results wave
//	Wave c=$("::Concs")
//	If(!waveexists(c))
//		print "Enter Concentrations of Injections in [M] or load sample concentration list from Menu!"
//		Make/D/N=(numpnts(wRef)) ::Concs
//		Edit/K=1 ::Concs
//		return -1
//	EndIf
//	Make/O/D/N=0 concs
//	For(i=0;i<numpnts(swave);i+=1)
//		If(swave[i])
//			Redimension/N=(numpnts(concs)+1) concs
//			concs[numpnts(concs)-1]=c[i]
//		EndIf
//	EndFor


	Variable pos=0
	For(i=0;i<numpnts(waves2fit);i+=1)
	
		//Data Wave to fit to
		Wave wf=$(waves2fit[numpnts(waves2fit)-1-i])
		W_coef[0]=wf[wPstart[i]]
		
		//Make constraints wave for fitting
		Make/O/T wConstraints={"K1 >= 0","K2 >= 0", "K3 >= 0","K4 >= 0","K5 >= 0"}
		
		print pstartfit,pendfit
		//Fit Data Range using given Fit Function
		FuncFit/W=2/N/Q/L=(numpnts(w))/X/H="1000001"/NTHR=1 DissFit3 W_coef wf[wPstart[i],Pendfit] /D/R/A=0/C=wConstraints
		///TBOX=857
		
		ModifyGraph rgb($("fit_"+nameofwave(wf)))=(0,0,65280)	//display fit in blue
	
		//Write Fit Results into fitRES wave in Fit Folder
		res[i][0]=W_coef[0]	//R0
		res[i][1]=W_coef[1]	//R1
		res[i][2]=W_coef[2]	//R2
		res[i][3]=W_coef[3]	//koff1
		res[i][4]=W_coef[4]	//koff2
		res[i][5]=W_coef[5]	//koff3
		res[i][6]=W_coef[6]	//t0
		res[i][7]=W_coef[0]-W_coef[1]-W_coef[2]	//R3
		

		//Calculate Total equilibrum response from fit results
		Variable j=0
		Do
			j+=1
		While(!swave[(numpnts(swave))-j] && j<(numpnts(swave)-1))	
		swave[(numpnts(swave))-j]=0		
		
		DoUpdate
	EndFor
	
	edit/K=1 res	//show fit results
End

Function showResults (ctrlName) : ButtonControl
	String ctrlName
	
	Edit/K=1 :Fits:wFitted,:Fits:wManOffFitRes
	
End

Function manfit (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF sref=GetDataFOlderDFR()
	SetDataFolder ::
	Variable/G DCrate
	SetDataFolder sref
	
	String sDataWaveName=StringByKey("TNAME",CsrInfo(A))
	If(!cmpstr(sDataWaveName,""))
		print "Wrong window active or missing Cursor A!"
		return -1
	EndIf
	Variable fitStartPoint=PCsr(A)
	Variable fitStartTime=XCsr(A)
	
	ControlInfo/W=mFit sv1
	Variable deltaT=V_value
	Variable fitEndPoint=fitStartPoint+deltaT*DCrate*10
	
	If(!exists(":Fits:wFitted"))
		Make/T/O/N=0 :Fits:wFitted
		Wave/T wNames=:Fits:wFitted
	Else
		Wave/T wNames=:Fits:wFitted
	Endif
	
	If(!exists(":Fits:wManOffFitRes"))
		make/D/O/N=(0,7) :Fits:wManOffFitRes //R1,R2,R2,koff1,koff2,koff3,deltaT
		Wave wRes=:Fits:wManOffFitRes
	else
		Wave wRes=:Fits:wManOffFitRes
	Endif
	
	If(!exists(":Fits:koff1"))
		make/D/O/N=0 :Fits:koff1
		Wave k1=:Fits:koff1
	else
		Wave k1=:Fits:koff1
	Endif
	
	If(!exists(":Fits:koff2"))
		make/D/O/N=0 :Fits:koff2
		Wave k2=:Fits:koff2
	else
		Wave k2=:Fits:koff2
	Endif
	
	If(!exists(":Fits:koff3"))
		make/D/O/N=0 :Fits:koff3
		Wave k3=:Fits:koff3
	else
		Wave k3=:Fits:koff3
	Endif
	
	
	Wave wD=$(sDataWaveName)
	Make/O/D/N=7 W_coef
	
	W_coef[6]=XCsr(A)
	W_coef[0]=VCsr(A)
	ControlInfo/W=mFit sv2
	W_coef[1]=V_value
	ControlInfo/W=mFit sv3
	W_coef[2]=V_value
	ControlInfo/W=mFit sv4
	W_coef[3]=V_value
	ControlInfo/W=mFit sv5
	W_coef[4]=V_value
	ControlInfo/W=mFit sv6
	W_coef[5]=V_value
	
	Display/K=1 wD
	SetAxis bottom,fitStartTime,fitStartTime+deltaT
	
	
	
	Make/O/T wConstraints={"K1 >= 0","K2 >= 0", "K3 >= 0","K4 >= 0","K5 >= 0"}
	
	//Curve Fit special variables
	Variable V_fitOptions=4
	Variable V_FitError=0
	
	FuncFit/W=2/N/Q/L=(10000)/X/H="1000001"/NTHR=1/TBOX=857 DissFit3 W_coef wD[fitStartPoint,fitEndPoint] /D/R/A=1/C=wConstraints

	ModifyGraph rgb($("fit_"+nameofwave(wD)))=(0,0,65280)	//display fit in blue
	ModifyGraph rgb($("Res_"+nameofwave(wD)))=(0,0,0) //display residual in black
	SetAxis Res_Left -50,50
	ModifyGraph zero(Res_Left)=4
	
	
//R1,R2,R3,koff1,koff2,koff3,deltaT
		
		If(!V_FitError)
		
		print "Fit converged properly"
		
		Redimension/N=(numpnts(wNames)+1) wNames
		wNames[numpnts(wNames)-1]=sDataWaveName
		Redimension/N=(dimsize(wRes,0)+1,-1) wRes, k1, k2, k3
		
		wRes[dimsize(wRes,0)-1][0]=W_coef[1]	//R1
		wRes[dimsize(wRes,0)-1][1]=W_coef[2]	//R2
		wRes[dimsize(wRes,0)-1][2]=W_coef[0]-W_coef[1]-W_coef[2]	//R3
		wRes[dimsize(wRes,0)-1][3]=W_coef[3]	//k1
		wRes[dimsize(wRes,0)-1][4]=W_coef[4]	//k2
		wRes[dimsize(wRes,0)-1][5]=W_coef[5]	//k3
		wRes[dimsize(wRes,0)-1][6]=deltaT	//t0
		
		k1[dimsize(k1,0)-1]=W_coef[3]	//k1
		k2[dimsize(k2,0)-1]=W_coef[4]	//k2
		k3[dimsize(k3,0)-1]=W_coef[5]	//k3
		
		
		else
		
		print "Try again! Error Code (",V_FitError,")"

		EndIf
End






Function DissFit3(w,t) : FitFunc
	Wave w
	Variable t

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(t) = A0+((R0-R1-R2)*exp(-kd1*(t-t0))+(R1)*exp(-kd2*(t-t0))+(R2)*exp(-kd3*(t-t0)))
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ t
	//CurveFitDialog/ Coefficients 7
	//CurveFitDialog/ w[0] = R0
	//CurveFitDialog/ w[1] = R1
	//CurveFitDialog/ w[2] = R2
	//CurveFitDialog/ w[3] = kd1
	//CurveFitDialog/ w[4] = kd2
	//CurveFitDialog/ w[5] = kd3
	//CurveFitDialog/ w[6] = t0

	return (w[0]-w[1]-w[2])*exp(-w[5]*(t-w[6]))+(w[1])*exp(-w[3]*(t-w[6]))+(w[2])*exp(-w[4]*(t-w[6]))
End